 --
 --
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEEEEEEE
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEE
 --    P               A          A    R R                       S    E
 --    P               A          A    R  R                      S    E
 --    P               A          A    R   R                     S    E
 --    P               A          A    R     R                   S    E
 --    P               A          A    R       R                 S    E
 --    P               A          A    R         R     SSSSSSSSSSS    EEEEEEEEEEEE
 --
 --
 --
 --
 --     Copyright (C)  2002  Daniel Gaudry (Daniel.Gaudry@wanadoo.fr)
 --     9 av calmels
 --     92270 bois colombes  france
 --     Home +33147862334
 --     Cell +33664195009
 --     Work +33148575063
 --     Fax  +33148571106
 --
 --     This library is free software; you can redistribute it and/or
 --     modify it under the terms of the GNU Library General Public
 --     License as published by the Free Software Foundation; either
 --     version 2 of the License, or (at your option) any later version.
 --
 --     This library is distributed in the hope that it will be useful,
 --     but WITHOUT ANY WARRANTY; without even the implied warranty of
 --     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 --     Library General Public License for more details.
 --
 --     You should have received a copy of the GNU Library General Public
 --     License along with this library; if not, write to the Free
 --     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 --     MA 02111-1307, USA
 
 --| version 1.00 may         02 nd 2002 initial coding
 
 with Ada.Text_Io;
 with Ae_20_A;
 with Ae_Global;
 with Ae_200;
 
 package body Ae_20
 is
 --|
 --|                          ||
 --|                          | parse  |
 --|                          |________|
 --|
    procedure Parse(The_Line           : in     String;
                    How_Many_Words     :    out Long_Integer;
                    Token_Record_Array :    out Token_Record_Array_Type)
    is
 
    Current_Command          : Ae_20_A.Command_Type         := Ae_20_A.Command_Type'First;
    Current_State            : Ae_20_A.State_Type           := Ae_20_A.State_Type'First;
    Previous_State           : Ae_20_A.State_Type           := Ae_20_A.State_Type'First;
    Current_Character        : Character                    := ' ';
    Current_Index            : Positive                     := The_Line'First;
    Token_Starts_At          : Positive                     := The_Line'First;
    Kind_Of_Token            : Ae_Global.Kind_Of_Token_Type := Ae_Global.Space;
    Previous_Is_Single_Quote : Boolean                      := False;
 
    use type Ae_Global.Kind_Of_Token_Type;
    use type Ae_20_A.State_Type;
    use type Ae_20_A.Command_Type;
 
    begin
    --|
    --|
    --|
    How_Many_Words := 0;
    --|
    --|  THE STATE COMMAND TABLE MUST HANDLE ALL CASES By D E F I N I T I O N
    --|
    loop
       --|
       --|     go one COMMAND further
       --|
       Current_Character := The_Line(Current_Index);
       Current_Command   := Ae_20_A.Look_Up_Table(Character'Pos(Current_Character));
       Current_State     := Ae_20_A.Command_State_Matrix(Current_State, Current_Command);
       --|
       --|
       --|       d e b u g   m e s s a g e      
       --|_____________________________________________________________________________
       --|
       --Ada.Text_Io.Put_Line("AE_20 Current_Character >"
       --& The_Line(Current_Index)
       --& "<Current_Command "
       --& Ae_20_A.Command_Type'Image(Current_Command)
       --&  " Current_State "
       --& Ae_20_A.State_Type'Image(Current_State)
       --& " Previous_State "
       --& Ae_20_A.State_Type'Image(Previous_State));
       --|
       --|
       --|    e n d   d e b u g   m e s s a g e  
       --|_____________________________________________________________________________
       --|
 
       --|
       --|    .. as a separator after digit such as 1..
       --|
       if Current_State = 3
          and then (Previous_State = 30
                    or else Previous_State = 23)
          then
          Current_Index  := Integer'Max(1, Integer(Current_Index - 1));
          Previous_State := 18;
          Current_State  := 0;
       end if;
       --|
       --|    in a finite COMMAND automaton there is
       --|    no look ahead so they must be a special treatment for
       --|    spaces as a separator(s)
       --|
       if Ae_20_A.Space = Current_Command
          and then Current_State = 34
          then
          Token_Starts_At := 1 + Current_Index;
       end if;
       --|
       --|     END OF TOKEN
       --|     
       if Current_State = 0
          or else Current_Index = The_Line'Last
          then
          --|
          --|    A S S I G N   K I N D   O F   T O K E N
          --|    
          case Previous_State
             is
             --|
             --| ||
             --| |end of token ( but not a space ) |
             --| |_________________________________|
             --|
             --when 0 =>
 
             --Current_Index := Current_Index + 1;
             --Kind_Of_Token := Ae_Global.Special_Character;
             --|
             --| ||
             --| |integer |
             --| |________|
             --|
             when 18 =>
 
             Kind_Of_Token := Ae_Global.Number;
             --|
             --| ||
             --| |based number / NUMBER WITH E NOTATION     |
             --| |__________________________________________|
             --|
             when 26 | 29 =>
 
             Kind_Of_Token := Ae_Global.Number;
             --|
             --| ||
             --| |float  |
             --| |_______|
             --|
             when 31 =>
 
             Kind_Of_Token := Ae_Global.Number;
             --|
             --| ||
             --| |variable, reserved word or attribute      |
             --| |__________________________________________|
             --|
             when 1 | 2 =>
             --|
             --|  attribute ?
             --|
             if Previous_Is_Single_Quote
                then
                if Ae_200.Is_Attribute(The_Word => The_Line(Token_Starts_At .. Current_Index - 1))
                   then
                   Kind_Of_Token := Ae_Global.Attribute;
                   --|
                   --| not an  attribute  => error
                   --|
                   else
                   Kind_Of_Token := Ae_Global.Special_Character;
                end if;
                --|
                --|   reserved word ?
                --|
                else
                if Ae_200.Is_Reserved_Word(The_Word => The_Line(Token_Starts_At .. Current_Index - 1))
                   then
                   Kind_Of_Token := Ae_Global.Reserved_Word;
                   --|
                   --| variable
                   --|
                   else
                   Kind_Of_Token := Ae_Global.Variable_Name;
                end if;
             end if;
             --|
             --|   reset
             --|
             Previous_Is_Single_Quote := False;
             --|
             --| ||
             --| |separator |
             --| |__________|
             --|
             when 3 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 16 =>
 
             Kind_Of_Token            := Ae_Global.Separator;
             Previous_Is_Single_Quote := False;
 
             --|
             --| ||
             --| |SINGLE QUOTE |
             --| |_____________|
             --|
             when 5 =>
 
             Current_Index            := Current_Index - 1;
             Kind_Of_Token            := Ae_Global.Separator;
             Previous_Is_Single_Quote := True;
             --|
             --| ||
             --| |miscellaneous |
             --| |______________|
             --|
             when 17 =>
 
             Kind_Of_Token := Ae_Global.Special_Character;
             --|
             --| ||
             --| |string        |
             --| |______________|
             --|
             when 7 =>
 
             Kind_Of_Token := Ae_Global.String;
             --|
             --| ||
             --| | Character    |
             --| |______________|
             --|
             when 33 =>
 
             Kind_Of_Token := Ae_Global.String;
             --|
             --| ||
             --| | comment       |
             --| |_______________|
             --|
             when 15 =>
 
             Kind_Of_Token := Ae_Global.Comment;
             --|
             --| ||
             --| | error         |
             --| |_______________|
             --|
             when others =>
 
             Kind_Of_Token := Ae_Global.Special_Character;
 
          end case;
          --|
          --| ||
          --| | L O A D   T O K E N |
          --| |_____________________|
          --|
          if Kind_Of_Token /= Ae_Global.Space
             then
             --|
             --|      update
             --|
             How_Many_Words := 1 + How_Many_Words;
             --|
             --|   load token
             --|
             Token_Record_Array(How_Many_Words) := (Kind_Of_Token => Kind_Of_Token,
                                                    Token_Ends_At => Long_Integer(Current_Index - 1));
             --|
             --|
             --|       d e b u g   m e s s a g e      
             --|_____________________________________________________________________________
             --|
             --Ada.Text_Io.Put_Line("AE_20  >"
             --& The_Line(Token_Starts_At .. Current_Index - 1)
             --& "< HMW"
             --& Long_Integer'Image(How_Many_Words)
             --& " Previous_State "
             --& Ae_20_A.State_Type'Image(Previous_State)
             --& Boolean'Image(Previous_Is_Single_Quote));
             --|
             --|
             --|    e n d   d e b u g   m e s s a g e  
             --|_____________________________________________________________________________
             --|
 
             --|
             --|     restart STATE/COMMAND machine for next token
             --|
             Token_Starts_At := Current_Index;
          end if;
          exit when Current_Index = The_Line'Last;
          --|
          --|  continue STATE/COMMAND machine for current  token
          --|
          else
          Current_Index := Current_Index + 1;
       end if;
       --|
       --| ||
       --| |   keep for kind of token assignment      |
       --| |__________________________________________|
       --|
       Previous_State := Current_State;
    end loop;
    end Parse;
 end Ae_20;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
