 --
 --
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEEEEEEE
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEE
 --    P               A          A    R R                       S    E
 --    P               A          A    R  R                      S    E
 --    P               A          A    R   R                     S    E
 --    P               A          A    R     R                   S    E
 --    P               A          A    R       R                 S    E
 --    P               A          A    R         R     SSSSSSSSSSS    EEEEEEEEEEEE
 --
 --
 --
 --
 --     Copyright (C)  2002  Daniel Gaudry (Daniel.Gaudry@wanadoo.fr)
 --     9 av calmels
 --     92270 bois colombes  france
 --     Home +33147862334
 --     Cell +33664195009
 --     Work +33148575063
 --     Fax  +33148571106
 --
 --     This library is free software; you can redistribute it and/or
 --     modify it under the terms of the GNU Library General Public
 --     License as published by the Free Software Foundation; either
 --     version 2 of the License, or (at your option) any later version.
 --
 --     This library is distributed in the hope that it will be useful,
 --     but WITHOUT ANY WARRANTY; without even the implied warranty of
 --     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 --     Library General Public License for more details.
 --
 --     You should have received a copy of the GNU Library General Public
 --     License along with this library; if not, write to the Free
 --     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 --     MA 02111-1307, USA
 --
 --
 -- Version 1.00 March7 th, 2002
 --
 --
 --
 --
 --
 
 with Rt;
 
 package Gram
 is
 
 
 function Do_It return Boolean;
 
 --|
 --| common data to follow the progress of the parser (cuurent state beeing investigated)
 --|
 Current_Code_State : Rt.Code_State_Type;
 
 private
 --|
 --|      error messsage definition
 --|
 type String_Access_Type is access all String;
 
 type Error_Message_Type is
 record
    Error_Found          : Boolean            := False;
    Line_Number          : Long_Integer       := 0;
    Character_Position   : Long_Integer       := 0;
    Error_Message_Access : String_Access_Type := null;
 end record;
 
 Error_Message : Error_Message_Type;
 
 --|
 --| needed to alleviate the order of the routines
 --|
 function Index_Subtype_Definition return Boolean;
 function Range_Attribute_Reference return Boolean;
 function Pragma_Argument_Association return Boolean;
 function Direct_Name return Boolean;
 function Explicit_Dereference return Boolean;
 function Indexed_Component return Boolean;
 function Slice return Boolean;
 function Selected_Component return Boolean;
 function Attribute_Reference return Boolean;
 function Type_Conversion return Boolean;
 function Function_Call return Boolean;
 function Component_Clause return Boolean;
 function Position return Boolean;
 function First_Bit return Boolean;
 function Last_Bit return Boolean;
 function Subprogram_Specification return Boolean;
 function Discrete_Choice return Boolean;
 function Case_Statement_Alternative return Boolean;
 function Expression return Boolean;
 function Condition return Boolean;
 function Implicit_Dereference return Boolean;
 function Delay_Until_Statement return Boolean;
 function Delay_Relative_Statement return Boolean;
 function Relation return Boolean;
 function Operator_Symbol return Boolean;
 function Exception_Handler return Boolean;
 function Statement return Boolean;
 function Handled_Sequence_Of_Statements return Boolean;
 function Generic_Declaration return Boolean;
 function Generic_Instantiation return Boolean;
 function Library_Unit_Body return Boolean;
 function Library_Unit_Renaming_Declaration return Boolean;
 function Library_Unit_Declaration return Boolean;
 function Use_Package_Clause return Boolean;
 function Use_Type_Clause return Boolean;
 function Compilation_Unit return Boolean;
 function Context_Clause return Boolean;
 function Library_Item return Boolean;
 function Subunit return Boolean;
 function Context_Item return Boolean;
 function With_Clause return Boolean;
 function Defining_Program_Unit_Name return Boolean;
 function Parameter_Specification return Boolean;
 function Parameter_Profile return Boolean;
 function Defining_Designator return Boolean;
 function Formal_Part return Boolean;
 function Parameter_And_Result_Profile return Boolean;
 function Full_Type_Declaration return Boolean;
 function Incomplete_Type_Declaration return Boolean;
 function Private_Type_Declaration return Boolean;
 function Private_Extension_Declaration return Boolean;
 function Label return Boolean;
 function Simple_Statement return Boolean;
 function Compound_Statement return Boolean;
 function Null_Statement return Boolean;
 function Assignment_Statement return Boolean;
 function Exit_Statement return Boolean;
 function Goto_Statement return Boolean;
 function Procedure_Call_Statement return Boolean;
 function Return_Statement return Boolean;
 function Entry_Call_Statement return Boolean;
 function Requeue_Statement return Boolean;
 function Delay_Statement return Boolean;
 function Abort_Statement return Boolean;
 function Raise_Statement return Boolean;
 function Code_Statement return Boolean;
 function If_Statement return Boolean;
 function Case_Statement return Boolean;
 function Loop_Statement return Boolean;
 function Block_Statement return Boolean;
 function Accept_Statement return Boolean;
 function Select_Statement return Boolean;
 function Unary_Adding_Operator return Boolean;
 function Relational_Operator return Boolean;
 function Simple_Expression return Boolean;
 function Term return Boolean;
 function Binary_Adding_Operator return Boolean;
 function Factor return Boolean;
 function Multiplying_Operator return Boolean;
 function Primary return Boolean;
 function Qualified_Expression return Boolean;
 function Allocator return Boolean;
 function Declarative_Item return Boolean;
 function Basic_Declarative_Item return Boolean;
 function Body_X return Boolean;
 function Representation_Clause return Boolean;
 function Use_Clause return Boolean;
 function Proper_Body return Boolean;
 function Body_Stub return Boolean;
 function Subprogram_Body return Boolean;
 function Package_Body return Boolean;
 function Task_Body return Boolean;
 function Protected_Body return Boolean;
 function Package_Specification return Boolean;
 function Entry_Declaration return Boolean;
 function Entry_Body return Boolean;
 function Selective_Accept return Boolean;
 function Timed_Entry_Call return Boolean;
 function Conditional_Entry_Call return Boolean;
 function Asynchronous_Select return Boolean;
 function Accept_Alternative return Boolean;
 function Delay_Alternative return Boolean;
 function Terminate_Alternative return Boolean;
 function Type_Declaration return Boolean;
 function Subtype_Declaration return Boolean;
 function Object_Declaration return Boolean;
 function Number_Declaration return Boolean;
 function Subprogram_Declaration return Boolean;
 function Abstract_Subprogram_Declaration return Boolean;
 function Package_Declaration return Boolean;
 function Renaming_Declaration return Boolean;
 function Exception_Declaration return Boolean;
 function Scalar_Constraint return Boolean;
 function Composite_Constraint return Boolean;
 function Range_Constraint return Boolean;
 function Digits_Constraint return Boolean;
 function Index_Constraint return Boolean;
 function Delta_Constraint return Boolean;
 function Discriminant_Constraint return Boolean;
 function Subtype_Indication return Boolean;
 function Array_Type_Definition return Boolean;
 function Single_Task_Declaration return Boolean;
 function Single_Protected_Declaration return Boolean;
 function Defining_Identifier_List return Boolean;
 function Constraint return Boolean;
 function Unknown_Discriminant_Part return Boolean;
 function Known_Discriminant_Part return Boolean;
 function Component_Declaration return Boolean;
 function Access_To_Object_Definition return Boolean;
 function Access_To_Subprogram_Definition return Boolean;
 function Range_X return Boolean;
 function Record_Aggregate return Boolean;
 function Extension_Aggregate return Boolean;
 function Array_Aggregate return Boolean;
 function Enumeration_Literal_Specification return Boolean;
 function Positional_Array_Aggregate return Boolean;
 function Named_Array_Aggregate return Boolean;
 function Object_Renaming_Declaration return Boolean;
 function Exception_Renaming_Declaration return Boolean;
 function Package_Renaming_Declaration return Boolean;
 function Subprogram_Renaming_Declaration return Boolean;
 function Generic_Renaming_Declaration return Boolean;
 function Subprogram_Body_Stub return Boolean;
 function Package_Body_Stub return Boolean;
 function Task_Body_Stub return Boolean;
 function Protected_Body_Stub return Boolean;
 function Generic_Subprogram_Declaration return Boolean;
 function Generic_Package_Declaration return Boolean;
 function Formal_Object_Declaration return Boolean;
 function Formal_Type_Declaration return Boolean;
 function Formal_Subprogram_Declaration return Boolean;
 function Formal_Package_Declaration return Boolean;
 function Real_Range_Specification return Boolean;
 function Iteration_Scheme return Boolean;
 function Record_Extension_Part return Boolean;
 function Formal_Private_Type_Definition return Boolean;
 function Formal_Derived_Type_Definition return Boolean;
 function Formal_Discrete_Type_Definition return Boolean;
 function Formal_Signed_Integer_Type_Definition return Boolean;
 function Formal_Modular_Type_Definition return Boolean;
 function Formal_Floating_Point_Definition return Boolean;
 function Formal_Ordinary_Fixed_Point_Definition return Boolean;
 function Formal_Decimal_Fixed_Point_Definition return Boolean;
 function Formal_Array_Type_Definition return Boolean;
 function Formal_Access_Type_Definition return Boolean;
 function Attribute_Definition_Clause return Boolean;
 function Enumeration_Representation_Clause return Boolean;
 function Record_Representation_Clause return Boolean;
 function At_Clause return Boolean;
 function Component_List return Boolean;
 function Component_Item return Boolean;
 function Enumeration_Type_Definition return Boolean;
 function Integer_Type_Definition return Boolean;
 function Real_Type_Definition return Boolean;
 function Record_Type_Definition return Boolean;
 function Access_Type_Definition return Boolean;
 function Derived_Type_Definition return Boolean;
 function Signed_Integer_Type_Definition return Boolean;
 function Modular_Type_Definition return Boolean;
 function Floating_Point_Definition return Boolean;
 function Fixed_Point_Definition return Boolean;
 function Ordinary_Fixed_Point_Definition return Boolean;
 function Decimal_Fixed_Point_Definition return Boolean;
 function Unconstrained_Array_Definition return Boolean;
 function Constrained_Array_Definition return Boolean;
 function Actual_Parameter_Part return Boolean;
 function Parameter_Association return Boolean;
 function Explicit_Actual_Parameter return Boolean;
 function Loop_Parameter_Specification return Boolean;
 function Type_Definition return Boolean;
 function Task_Type_Declaration return Boolean;
 function Protected_Type_Declaration return Boolean;
 function Discriminant_Specification return Boolean;
 function Access_Definition return Boolean;
 function Component_Definition return Boolean;
 function Discrete_Subtype_Definition return Boolean;
 function Discrete_Range return Boolean;
 function Discriminant_Association return Boolean;
 function Record_Definition return Boolean;
 function Variant_Part return Boolean;
 function Variant return Boolean;
 function Discrete_Choice_List return Boolean;
 function General_Access_Modifier return Boolean;
 function Defining_Operator_Symbol return Boolean;
 function Selector_Name return Boolean;
 function Attribute_Designator return Boolean;
 function Range_Attribute_Designator return Boolean;
 function Record_Component_Association_List return Boolean;
 function Record_Component_Association return Boolean;
 function Component_Choice_List return Boolean;
 function Array_Component_Association return Boolean;
 function Ancestor_Part return Boolean;
 function Task_Definition return Boolean;
 function Task_Item return Boolean;
 function Protected_Definition return Boolean;
 function Guard return Boolean;
 function Protected_Operation_Declaration return Boolean;
 function Protected_Element_Declaration return Boolean;
 function Select_Alternative return Boolean;
 function Protected_Operation_Item return Boolean;
 function Entry_Index return Boolean;
 function Entry_Body_Formal_Part return Boolean;
 function Entry_Barrier return Boolean;
 function Entry_Index_Specification return Boolean;
 function Entry_Call_Alternative return Boolean;
 function Triggering_Statement return Boolean;
 function Triggering_Alternative return Boolean;
 function Generic_Actual_Part return Boolean;
 function Generic_Formal_Parameter_Declaration return Boolean;
 function Generic_Formal_Part return Boolean;
 function Abortable_Part return Boolean;
 function Formal_Type_Definition return Boolean;
 function Generic_Association return Boolean;
 function Explicit_Generic_Actual_Parameter return Boolean;
 function Mode_X return Boolean;
 function Subprogram_Default return Boolean;
 function Formal_Package_Actual_Part return Boolean;
 function Enumeration_Aggregate return Boolean;
 function Mod_Clause return Boolean;
 function Choice_Parameter_Specification return Boolean;
 function Exception_Choice return Boolean;
 function Defining_Character_Literal return Boolean;
 
 
 end Gram;
 
 
 
 
