 --
 --
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEEEEEEE
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEE
 --    P               A          A    R R                       S    E
 --    P               A          A    R  R                      S    E
 --    P               A          A    R   R                     S    E
 --    P               A          A    R     R                   S    E
 --    P               A          A    R       R                 S    E
 --    P               A          A    R         R     SSSSSSSSSSS    EEEEEEEEEEEE
 --
 --
 --
 --
 --     Copyright (C)  2002  Daniel Gaudry (Daniel.Gaudry@wanadoo.fr)
 --     9 av calmels
 --     92270 bois colombes  france
 --     Home +33147862334
 --     Cell +33664195009
 --     Work +33148575063
 --     Fax  +33148571106
 --
 --     This library is free software; you can redistribute it and/or
 --     modify it under the terms of the GNU Library General Public
 --     License as published by the Free Software Foundation; either
 --     version 2 of the License, or (at your option) any later version.
 --
 --     This library is distributed in the hope that it will be useful,
 --     but WITHOUT ANY WARRANTY; without even the implied warranty of
 --     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 --     Library General Public License for more details.
 --
 --     You should have received a copy of the GNU Library General Public
 --     License along with this library; if not, write to the Free
 --     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 --     MA 02111-1307, USA
 --
 --
 -- Version 1.00 March7 th, 2002
 --
 --
 --
 --
 --
 with Ae_200;
 with Rt;
 with Rw;
 with Ada.Text_Io;
 --|
 --|
 --| Version 1.00 April         4 th 2002 initial coding
 package body Name_Test
 is
 
 --|
 --|
 --|
 --|                                 ||
 --|                                 |      Number_Of       |
 --|                                 |______________________|
 --|
    function Number_Of(The_Token : in     String) return Integer
    is
    Number : Integer := Ae_200.Number_Of(The_Word => The_Token);
    begin
    delay 0.0;
    --|
    --|0 : not a reserved  word  seek if variable string or number
    --|
    if 0 = Number and then (The_Token = Rt.Identifier
                               or else The_Token = Rt.Number
                               or else The_Token = Rt.Char_Or_String)
       then
       Number := Look_Up_Table'Last;
    end if;
    --|
    --|0 : not asigned yet => separator ???
    --|
    if 0 = Number
       then
       --|
       --|seek separator
       --|
       for R in Rw.All_Separators'Range loop
          --|
          --|check word
          --|
          if The_Token = Rw.All_Separators(R).all
             then
             Number := R;
             exit;
          end if;
       end loop;
    end if;
    --|
    --|0 : not asigned yet => delimiter ???
    --|
    if 0 = Number
       then
       --|
       --|seek delimiters
       --|
       for R in Rw.All_Delimiters'Range loop
          --|
          --|check word
          --|
          if The_Token = Rw.All_Delimiters(R).all
             then
             Number := R;
             exit;
          end if;
       end loop;
    end if;
    --|
    --|
    --|       d e b u g   m e s s a g e      
    --|_____________________________________________________________________________
    --|
    Rt.Trace(" The_Token >"
             & The_Token
             & "<  NUMBER "
             & Integer'Image(Number)
             & "COMMAND"
             & Command_Type'Image(Look_Up_Table(Number)));
    --|
    --|
    --|    e n d   d e b u g   m e s s a g e  
    --|_____________________________________________________________________________
    --|
    return Number;
    end Number_Of;
 --|
 --|              ||
 --|              |  Parenthesis       |
 --|              |____________________|
 --|
    procedure Parenthesis
    is
    Token_Number : Integer := Number_Of(The_Token => Rt.Current(Current_Code_State).all);
    begin
    if Rw.Left_Parenthesis = Token_Number
       then
       Left_Par_Count := 1 + Left_Par_Count;
       elsif Rw.Right_Parenthesis = Token_Number
       then
       Left_Par_Count := - 1 + Left_Par_Count;
    end if;
    end Parenthesis;
 --|
 --|              ||
 --|              |  Is_Name       |
 --|              |________________|
 --|
    function Is_Name return Boolean
    is
    Current_State    : State_Type   := Starting_State;
    Previous_State   : State_Type   := Starting_State;
    Current_Command  : Command_Type := Command_Type'First;
    Previous_Command : Command_Type := Command_Type'First;
    Returned_Status  : Boolean      := True;
    begin
    --|
    --| loop on finite states automaton
    --|
    loop
       --|
       --| get number from token
       --|
       Token_Number := Number_Of(The_Token => Rt.Current(Current_Code_State).all);
       Next_Number  := Number_Of(The_Token => Rt.Next(Current_Code_State).all);
       --|
       --|get command from number using look up table
       --|
       Current_Command := Look_Up_Table(Token_Number);
       --|
       --| get next state from finite state automaton state/command matrix
       --|
       Current_State := State_Command_Matrix(Previous_State, Current_Command);
       --|
       --|
       --|       d e b u g   m e s s a g e      
       --|_____________________________________________________________________________
       --|
       Rt.Trace("Previous_State"
                & State_Type'Image(Previous_State)
                & " Current_State"
                & State_Type'Image(Current_State)
                & " Previous_Command"
                & Command_Type'Image(Previous_Command)
                & " Current_Command"
                & Command_Type'Image(Current_Command)
                & " Depth"
                & Integer'Image(Depth)
                & " Left_Par_count "
                & Integer'Image(Left_Par_Count));
 
       Previous_State   := Current_State;
       Previous_Command := Current_Command;
 
       --|
       --|
       --|    e n d   d e b u g   m e s s a g e  
       --|_____________________________________________________________________________
       --|
 
       --|
       --| => is terminal if no recursion  i.e.  no (
       --|
       Exit_When_Depth_Zero := Depth = 0 and then Depth_Zero(Look_Up_Table(Next_Number));
       --|
       --| 'and then' is not The Same As 'then'
       --|
       End_Token_Found := Successful_End(Next_Number) and 11 /= Current_State;
 
       exit when Exit_When_Depth_Zero or else End_Token_Found;
       exit when (08 = Look_Up_Table(Next_Number)) and then (Current_Command = 03);
       --|
       --| act depending on current state
       --|
       case Current_State is
          --|
          --| error !!!   return false  no read next token
          --|
          when Error_State =>
          --|
          --|
          --|       d e b u g   m e s s a g e      
          --|_____________________________________________________________________________
          --|
          Rt.Trace("error state return false "
                   & State_Type'Image(Previous_State)
                   & " Current_State"
                   & State_Type'Image(Current_State)
                   & " Previous_Command"
                   & Command_Type'Image(Previous_Command)
                   & " Current_Command"
                   & Command_Type'Image(Current_Command));
          --|
          --|
          --|    e n d   d e b u g   m e s s a g e  
          --|_____________________________________________________________________________
          --|
          return False;
          --|
          --| start read next
          --|
          when Starting_State =>
          Rt.Read(Current_Code_State);
          Parenthesis;
          --|
          --| ok read next
          --|
          when Ok_State =>
          --|
          --|
          --|       d e b u g   m e s s a g e      
          --|_____________________________________________________________________________
          --|
          Rt.Trace("returning Previous_State"
                   & State_Type'Image(Previous_State)
                   & " Current_State"
                   & State_Type'Image(Current_State)
                   & " Previous_Command"
                   & Command_Type'Image(Previous_Command)
                   & " Current_Command"
                   & Command_Type'Image(Current_Command)
                   & " Depth"
                   & Integer'Image(Depth));
          --|
          --|
          --|    e n d   d e b u g   m e s s a g e  
          --|_____________________________________________________________________________
          --|
          Rt.Read(Current_Code_State);
          Parenthesis;
          return True;
          --|
          --| recusion
          --|
          when Recursion_State =>
          --|
          --|read next
          --|
          Rt.Read(Current_Code_State);
          Parenthesis;
          --|
          --|  set recusion depth
          --|
          Depth := 1 + Depth;
          --|
          --| RECURSIVE CALL
          --|
          Returned_Status := Is_Name;
          --|
          --|return from recursion set recursion depth
          --|
          Depth := Depth - 1;
          --|
          --| error exit
          --|
          exit when not Returned_Status;
          --|
          --| any other state read next token
          --|
          when others =>
          Rt.Read(Current_Code_State);
          Parenthesis;
       end case;
       --|
       --| end automaton loop
       --|
    end loop;
    --|
    --| set status
    --|
    Returned_Status := Returned_Status and then (Exit_When_Depth_Zero or Exit_State_Ok(Current_State));
    --|
    --|
    --|       d e b u g   m e s s a g e      
    --|_____________________________________________________________________________
    --|
    Rt.Trace("exit loop Previous_State"
             & State_Type'Image(Previous_State)
             & " Current_State"
             & State_Type'Image(Current_State)
             & " Previous_Command"
             & Command_Type'Image(Previous_Command)
             & " Current_Command"
             & Command_Type'Image(Current_Command)
             & " Depth"
             & Integer'Image(Depth)
             & " Returned_Status "
             & Boolean'Image(Returned_Status));
    --|
    --|
    --|    e n d   d e b u g   m e s s a g e  
    --|_____________________________________________________________________________
    --|
 
    --|
    --| return status
    --|
    return Returned_Status;
    end Is_Name;
 --|
 --|
 --|
 --|                                 ||
 --|                                 |      Test_Name       |
 --|                                 |______________________|
 --|
    procedure Test_Name(Code_State                 : in out Rt.Code_State_Type;
                        Ok                         :    out Boolean;
                        Skip_Last_Left_Parenthesis : in     Boolean := False)
    is
    Result : Boolean;
    --|save before proceeding
    Code_State_In_Test : Rt.Code_State_Type := Code_State;
    begin
    --|
    --|
    --|       d e b u g   m e s s a g e      
    --|_____________________________________________________________________________
    --|
    Rt.Trace("Test_Name entry **>"
             & Rt.Current_Line
             & "<**");
    Rt.Trace("Test_Name entry   >"
             & Rt.Current(Code_State).all
             & "<>"
             & Rt.Next(Code_State).all
             & "<>"
             & Rt.After(Code_State).all);
    Rt.Trace(Rt.Print(Code_State));
    --|
    --|
    --|    e n d   d e b u g   m e s s a g e  
    --|_____________________________________________________________________________
    --|
 
    --|
    --|init before proceeding
    --|
    Current_Code_State := Code_State;
    Depth              := 0;
    Left_Par_Count     := 0;
    Parenthesis;
    --|
    --| call and deal with result
    --|
    Result := Rt.Current(Current_Code_State).all /= "in"
    and then Is_Name;
    --|
    --| care for parenthesis
    --|
    Result := Result and then Left_Par_Count in - 1 .. 0;
    --|
    --|
    --|       d e b u g   m e s s a g e      
    --|_____________________________________________________________________________
    --|
    Rt.Trace("@@@@@@ Is_Name returns "
             & Integer'Image(Left_Par_Count)
             & "Result"
             & Boolean'Image(Result)
             & '>'
             & Rt.Current(Current_Code_State).all
             & '<'
             & Rt.Next(Current_Code_State).all
             & "<>"
             & Rt.After(Current_Code_State).all
             & "<>"
             & Rt.Print(Code_State));
    --|
    --|
    --|    e n d   d e b u g   m e s s a g e  
    --|_____________________________________________________________________________
    --|
    if Result
       then
       Code_State := Current_Code_State;
       Ok         := True;
       if not (Skip_Last_Left_Parenthesis and then - 1 = Left_Par_Count)
          then
          Rt.Read(Code_State);
       end if;
       else
       --|
       --| failed reset to entry values
       --|
       Code_State := Code_State_In_Test;
       Ok         := False;
    end if;
    --|
    --|
    --|       d e b u g   m e s s a g e      
    --|_____________________________________________________________________________
    --|
    Rt.Trace("Test_Name returns "
             & Boolean'Image(Ok)
             & "<>"
             & Rt.Current(Code_State).all
             & "<>"
             & Rt.Next(Code_State).all
             & "<>"
             & Rt.After(Code_State).all
             & "<>"
             & Rt.Print(Code_State));
    --|
    --|
    --|    e n d   d e b u g   m e s s a g e  
    --|_____________________________________________________________________________
    --|
    end Test_Name;
 end Name_Test;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
