 --|
 --
 --
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEEEEEEE
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEE
 --    P               A          A    R R                       S    E
 --    P               A          A    R  R                      S    E
 --    P               A          A    R   R                     S    E
 --    P               A          A    R     R                   S    E
 --    P               A          A    R       R                 S    E
 --    P               A          A    R         R     SSSSSSSSSSS    EEEEEEEEEEEE
 --
 --
 --
 --
 --     Copyright (C)  2002  Daniel Gaudry (Daniel.Gaudry@wanadoo.fr)
 --     9 av calmels
 --     92270 bois colombes  france
 --     Home +33147862334
 --     Cell +33664195009
 --     Work +33148575063
 --     Fax  +33148571106
 --
 --     This library is free software; you can redistribute it and/or
 --     modify it under the terms of the GNU Library General Public
 --     License as published by the Free Software Foundation; either
 --     version 2 of the License, or (at your option) any later version.
 --
 --     This library is distributed in the hope that it will be useful,
 --     but WITHOUT ANY WARRANTY; without even the implied warranty of
 --     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 --     Library General Public License for more details.
 --
 --     You should have received a copy of the GNU Library General Public
 --     License along with this library; if not, write to the Free
 --     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 --     MA 02111-1307, USA
 
 --| version 1.0 december 1998 original coding
 
 with Ada.Text_Io;
 with Ada.Tags;
 
 package body Poly_Dic_Tree
 is
 
 --|
 --|              ||
 --|              | Clear_Dictionary  |
 --|              |___________________|
 --|
    procedure Clear_Dictionary(The_Dictionary_Tree : in out Dictionary_Tree_Type)
    is
    --|
    --|              ||
    --|              | Clear_Next_Letter|
    --|              |__________________|
    --|
       procedure Clear_Next_Letter(Dictionary_Tree : in out Dictionary_Tree_Type)
       is
       begin
       --|
       --| loop On all Possible Char at That Level
       --|
       for Char in Character_Value_Type'Range loop
          --|
          --|  is is the end  no contineue loop yes recursive call
          --|
          if Dictionary_Tree.Node_Access_Array(Char) /= null
             then
             --|
             --| recursive call
             --|
             Clear_Next_Letter(Dictionary_Tree => Dictionary_Tree.Node_Access_Array(Char).all);
             --|
             --| back from recursive call clear node
             --|
             Dictionary_Tree.Node_Access_Array(Char) := null;
             Dictionary_Tree.Tagged_Data_Access      := null;
          end if;
       end loop;
       end Clear_Next_Letter;
    --|
    --|              ||
    --|              |main  Clear_Dictionary |
    --|              |_______________________|
    --|
    begin
    --|
    --|start customary recursion
    --|
    Clear_Next_Letter(Dictionary_Tree => The_Dictionary_Tree);
 
    Index    := 0;
    Node_Num := 0;
 
    end Clear_Dictionary;
 --|
 --|              ||
 --|              | Add_To_Dictionary |
 --|              |___________________|
 --|
    procedure Add_To_Dictionary(The_Record             : in     Tagged_Data_Type'Class;
                                In_The_Dictionary_Tree : in out Dictionary_Tree_Type;
                                With_The_Label         : in     String)
    is
    --|
    --|              ||
    --|              | Add_Word |
    --|              |__________|
    --|
       procedure Add_Word(In_The_Dictionary_Tree : in out Dictionary_Tree_Type;
                          With_The_Label         : in     String)
       is
       Char : Character := With_The_Label(With_The_Label'First);
       begin
       --|
       --| SUCH A CHARACTER ALREADY EXISTS IN THE DICTIONNARY ?
       --|
       if In_The_Dictionary_Tree.Node_Access_Array(Char) = null
          then
          --|
          --| NO, CREATE THE NEW NODE AND ASSIGN CHARACTER VALUE
          --|
          Node_Num                                       := 1 + Node_Num;
          In_The_Dictionary_Tree.Node_Access_Array(Char) := new Dictionary_Tree_Type;
          --|
          --| MAKE IT BLANK
          --|
          In_The_Dictionary_Tree.Node_Access_Array(Char).End_Of_Word       := False;
          In_The_Dictionary_Tree.Node_Access_Array(Char).Node_Access_Array := (others => null);
          --|
          --| ASSIGN CHAR VALUE
          --|
          In_The_Dictionary_Tree.Node_Access_Array(Char).Character_Value := Char;
       end if;
       --|
       --| IS IT THE LAST CHARACTER
       --|
       if With_The_Label'First = With_The_Label'Last
          then
          --|
          --| IS IT ALSO THE END OF A WORD PREVIOUSLY RECORDED
          --|
          if In_The_Dictionary_Tree.Node_Access_Array(Char).End_Of_Word = True
             then
             null;
             else
             --|
             --| NO  RECORD IT AND UPDATE
             --|
             In_The_Dictionary_Tree.Node_Access_Array(Char).End_Of_Word := True;
          end if;
          --|
          --|  LAST LETTER OF WORD => LOAD/UPDATE CLASS DATA
          --|
          In_The_Dictionary_Tree.Node_Access_Array(Char).Tagged_Data_Access
          := new Tagged_Data_Type'Class'(The_Record);
          else
          --|
          --|REMOVE ONE CHAR FROM THE WORD AND CALL AGAIN WITH THIS NODE
          --|
          Add_Word(In_The_Dictionary_Tree => In_The_Dictionary_Tree.Node_Access_Array(Char).all,
                   With_The_Label         => With_The_Label(1 + With_The_Label'First .. With_The_Label'Last));
       end if;
       end Add_Word;
    --|
    --|              ||
    --|              | main Add_To_Dictionary |
    --|              |________________________|
    --|
    begin
    Add_Word(In_The_Dictionary_Tree => In_The_Dictionary_Tree,
             With_The_Label         => With_The_Label);
    end Add_To_Dictionary;
 --|
 --|              ||
 --|              | Print_Dictionary |
 --|              |__________________|
 --|
    procedure Print_Dictionary(Dictionary_Tree : in     Dictionary_Tree_Type)
    is
    S                  : String(1 .. 200);
    Depth_Of_Recursion : Integer := 0;
    --|
    --|              ||
    --|              | Next_Letter |
    --|              |_____________|
    --|
       procedure Next_Letter(Dictionary_Tree : in     Dictionary_Tree_Type)
       is
       begin
       --|
       --| KEEP  TRACK OF RECURSION LEVEL
       --|
       Depth_Of_Recursion := 1 + Depth_Of_Recursion;
       --|
       --| LOOP ON ALL POSSIBLE CHAR AT THAT LEVEL
       --|
       for Char in Character_Value_Type'Range loop
          --|
          --| IF NULL NO SUCH CHAR WAS RECORDED
          --|
          if Dictionary_Tree.Node_Access_Array(Char) /= null
             then
             --|
             --|LOAD CHAR
             --|
             S(Depth_Of_Recursion) := Dictionary_Tree.Node_Access_Array(Char).Character_Value;
             --|
             --| IF END OF WORD PRINT
             --|
             if Dictionary_Tree.Node_Access_Array(Char).End_Of_Word
                then
                Ada.Text_Io.Put("->" & S(1 .. Depth_Of_Recursion) & Ascii.Lf);
             end if;
             --|
             --|RECURSE ONCE MORE
             --|
             Next_Letter(Dictionary_Tree => Dictionary_Tree.Node_Access_Array(Char).all);
          end if;
       end loop;
       --|
       --| UPDATE RECUSION LEVEL
       --|
       Depth_Of_Recursion := Depth_Of_Recursion - 1;
       end Next_Letter;
    --|
    --|              ||
    --|              | main Print_Dictionary |
    --|              |_______________________|
    --|
    begin
    --|
    --| CLEAN AND GO
    --|
    S := (S'Range               => ' ');
    Next_Letter(Dictionary_Tree => Dictionary_Tree);
    end Print_Dictionary;
 --|
 --|              ||
 --|              | Stat |
 --|              |______|
 --|
    procedure Stat(How_Many_Nodes_Created :    out Long_Integer)
    is
    begin
    How_Many_Nodes_Created := Node_Num;
    end Stat;
 --|
 --|              ||
 --|              | Visit_All |
 --|              |___________|
 --|
    procedure Visit_All(Dictionary_Tree : in     Dictionary_Tree_Type)
    is
    S                  : String(1 .. 200);
    Depth_Of_Recursion : Integer := 0;
    Next_One           : Boolean := True;
    --|
    --|              ||
    --|              | Next_Letter |
    --|              |_____________|
    --|
       procedure Next_Letter(Dictionary_Tree : in     Dictionary_Tree_Type)
       is
       begin
       if not Next_One
          then
          return;
       end if;
       --|
       --| KEEP  TRACK OF RECURSION LEVEL
       --|
       Depth_Of_Recursion := 1 + Depth_Of_Recursion;
       --|
       --| LOOP ON ALL POSSIBLE CHAR AT THAT LEVEL
       --|
       for Char in Character_Value_Type'Range loop
          --|
          --| IF NULL NO SUCH CHAR WAS RECORDED
          --|
          if Dictionary_Tree.Node_Access_Array(Char) /= null
             then
             --|
             --|LOAD CHAR
             --|
             S(Depth_Of_Recursion) := Dictionary_Tree.Node_Access_Array(Char).Character_Value;
             --|
             --| IF END OF WORD return to main
             --|
             if Dictionary_Tree.Node_Access_Array(Char).End_Of_Word
                then
 
                Iterate(The_Node_Access => Dictionary_Tree.Node_Access_Array(Char).Tagged_Data_Access,
                        Next_One        => Next_One,
                        The_Label       => S(1 .. Depth_Of_Recursion));
             end if;
             --|
             --|RECURSE ONCE MORE if user wants it
             --|
             if Next_One
                then
                Next_Letter(Dictionary_Tree => Dictionary_Tree.Node_Access_Array(Char).all);
             end if;
          end if;
       end loop;
       --|
       --| over ?
       --|
       if not Next_One then
          return;
       end if;
       --|
       --| UPDATE RECUSION LEVEL
       --|
       Depth_Of_Recursion := Depth_Of_Recursion - 1;
       end Next_Letter;
    --|
    --|              ||
    --|              |main  Visit_All |
    --|              |________________|
    --|
    begin
    --|
    --| CLEAN AND GO
    --|
    S := (S'Range => ' ');
 
    Next_Letter(Dictionary_Tree => Dictionary_Tree);
    end Visit_All;
 --|
 --|              ||
 --|              | Get_Record_Access_From_Label |
 --|              |______________________________|
 --|
    procedure Get_Record_Access_From_Label(From_The_Dictionary_Tree : in out Dictionary_Tree_Type;
                                           And_The_Label            : in     String;
                                           Tagged_Data_Access       :    out Tagged_Data_Access_Type)
    is
    --|
    --|              ||
    --|              | Seek_Word |
    --|              |___________|
    --|
       procedure Seek_Word(From_The_Dictionary_Tree : in out Dictionary_Tree_Type;
                           And_The_Label            : in     String)
       is
       Char : Character := And_The_Label(And_The_Label'First);
       begin
       --|
       --| SUCH A CHARACTER EXISTS IN THE DICTIONNARY ?
       --|
       if From_The_Dictionary_Tree.Node_Access_Array(Char) = null
          then
          raise No_Such_A_Word;
       end if;
       --|
       --| LAST LETTER
       --|
       if And_The_Label'First = And_The_Label'Last
          then
          --|
          --|IS IT ALSO THE END OF THE WORD
          --|
          if True = From_The_Dictionary_Tree.Node_Access_Array(Char).End_Of_Word
             then
             --|
             --| LOAD SEEKED FOR DATA
             --|
             Tagged_Data_Access := From_The_Dictionary_Tree.Node_Access_Array(Char).Tagged_Data_Access;
             else
             --|
             --| IF END OF WORD WITOUT END OF WORD
             --|
             raise No_Such_A_Word;
          end if;
          else
          --|
          --|REMOVE ONE CHAR FROM THE WORD AND CALL AGAIN WITH THIS NODE
          --|
          Seek_Word(From_The_Dictionary_Tree => From_The_Dictionary_Tree.Node_Access_Array(Char).all,
                    And_The_Label            => And_The_Label(1 + And_The_Label'First .. And_The_Label'Last));
       end if;
       end Seek_Word;
    --|
    --|              ||
    --|              |main  Get_Record_Access_From_Label |
    --|              |___________________________________|
    --|
    begin
    --|
    --| START RECURSION
    --|
    Seek_Word(From_The_Dictionary_Tree => From_The_Dictionary_Tree,
              And_The_Label            => And_The_Label);
    end Get_Record_Access_From_Label;
 ------------------------------------------------
 ------------------------------------------------
 ------------------------------------------------
 
 end Poly_Dic_Tree;
 
 
