 
--                               TESTING OF TYPE DECLARATIONS
 
 procedure Dic_Ext
 is
 type Table is array (1 .. 10) of Integer;
 function Peek_Message(Msg : access Claw.Win32.Message_Record) return X;
 subtype Index_Type is Integer range 1 .. Integer(How_Many_In_Storage);
 Spacing : constant := Integer'Last / 16;
 --To_The_Set         := new Node'(The_Item => The_Item, Next => To_The_Set);
 subtype Kind_Of_Token_Type is Elements_Type range Attribute .. Space;
 type Color is (White, Red, Yellow, Green, Blue, Brown, Black);
 type Column is range 1 .. 72;
 
 subtype Rainbow is Color range Red .. Blue;-- see 3.2.1
 subtype Red_Blue is Rainbow;
 subtype Int is Integer;
 subtype Small_Int is Integer range - 10 .. 10;
 subtype Up_To_K is Column range 1 .. K;-- see 3.2.1
 subtype Square is Matrix(1 .. 10, 1 .. 10);-- see 3.6
 subtype Male is Person(Sex => M);-- see 3.10.1
 type Local_Coordinate is new Coordinate;-- two different types
 type Midweek is new Day range Tue .. Thu;-- see 3.5.1
 type Counter is new Positive;-- same range as Positive
 type Special_Key is new Key_Manager.Key;-- see 7.3.1
 type Z is range S'First + 1 .. S'Last - 1;
 type Day is (Mon, Tue, Wed, Thu, Fri, Sat, Sun);
 type Suit is (Clubs, Diamonds, Hearts, Spades);
 type Gender is (M, F);
 type Level is (Low, Medium, Urgent);
 type Color is (White, Red, Yellow, Green, Blue, Brown, Black);
 type Light is (Red, Amber, Green);
 type Hexa is ('A','B','C','D','E','F');
 type Mixed is ('A','B','*', B, None,'?','%');
 subtype Weekday is Day range Mon .. Fri;
 subtype Major is Suit range Hearts .. Spades;
 subtype Rainbow is Color range Red .. Blue;-- the Color Red, not the Light
 type Roman_Digit is ('I','V','X','L','C','D','M');
 type Page_Num is range 1 .. 2_000;
 type Line_Size is range 1 .. Max_Line_Size;
 subtype Small_Int is Integer range - 10 .. 10;
 subtype Column_Ptr is Line_Size range 1 .. 10;
 subtype Buffer_Size is Integer range 0 .. Max;
 type Byte is mod 256;-- an unsigned byte
 type Hash_Index is mod 97;-- modulus is prime
 type Coefficient is digits 10 range - 1.0 .. 1.0;
 type Real is digits 8;
 type Mass is digits 7 range 0.0 .. 1.0E35;
 subtype Probability is Real range 0.0 .. 1.0;
 type Fraction is delta 2.0 ** (- 15) range - 1.0 .. 1.0;
 type Volt is delta 0.125 range 0.0 .. 255.0;
 type Fraction is delta System.Fine_Delta range - 1.0 .. 1.0;
 type Money is delta 0.01 digits 15;-- decimal fixed point
 subtype Salary is Money digits 10;
 type Vector is array (Integer range <>) of Real;
 type Matrix is array (Integer range <>, Integer range <>) of Real;
 type Bit_Vector is array (Integer range <>) of Boolean;
 type Roman is array (Positive range <>) of Roman_Digit;-- see 3.5.2	
 type Table is array (1 .. 10) of Integer;
 type Schedule is array (Day) of Boolean;
 type Line is array (1 .. Max_Line_Size) of Character;
 type Var_Line(Length : Natural) is
 record
    Image : String(1 .. Length);
 end record;
 subtype Positive is Integer range 1 .. Integer'Last;
 type String is array (Positive range <>) of Character;
 type Wide_String is array (Positive range <>) of Wide_Character;
 type Buffer(Size : Buffer_Size := 100) is -- see 3.5.4
 record
    Pos   : Buffer_Size := 0;
    Value : String(1 .. Size);
 end record;
 type Matrix_Rec(Rows, Columns : Integer) is
 record
    Mat : Matrix(1 .. Rows, 1 .. Columns);-- see 3.6
 end record;
 type Square(Side : Integer) is new Matrix_Rec(Rows    => Side,
                                               Columns => Side);
 type Double_Square(Number : Integer) is
 record
    Left  : Square(Number);
    Right : Square(Number);
 end record;
 type Item(Number : Positive) is
 record
    Content : Integer;
    -- no component depends on the discriminant
 end record;
 type Date is
 record
    Day   : Integer range 1 .. 31;
    Month : Month_Name;
    Year  : Integer range 0 .. 4000;
 end record;
 type Complex is
 record
    Re : Real := 0.0;
    Im : Real := 0.0;
 end record;
 type Device is (Printer, Disk, Drum);
 type State is (Open, Closed);
 type Peripheral(Unit : Device := Disk) is
 record
    Status : State;
    case Unit is
       when Printer =>
       Line_Count : Integer range 1 .. Page_Size;
       when others =>
       Cylinder : Cylinder_Index;
       Track    : Track_Number;
    end case;
 end record;
 subtype Drum_Unit is Peripheral(Drum);
 subtype Disk_Unit is Peripheral(Disk);
 type Point is tagged
 record
    X, Y : Real := 0.0;
 end record;
 type Expression is tagged null record;
 type Painted_Point is new Point with
 record
    Paint : Color := White;
 end record;
 
 --*-- Components X and Y are inherited
 type Literal is new Expression with
 record
    Value : Real;
 end record;
 type Expr_Ptr is access all Expression'Class;-- see 3.10
 type Binary_Operation is new Expression with
 record -- an internal node in an Expression tree
    Left, Right : Expr_Ptr;
 end record;
 type Addition is new Binary_Operation with null record;
 type Subtraction is new Binary_Operation with null record;
 -- No additional components needed for these extensions
 
 Tree : Expr_Ptr := new Addition'(Left                   => new Literal'(Value => 5.0),
                                  Right                  =>
                                  new Subtraction'(Left  => new Literal'(Value => 13.0),
                                                   Right => new Literal'(Value => 7.0)));
 type Peripheral_Ref is access Peripheral;-- see 3.8.1
 type Binop_Ptr is access all Binary_Operation'Class;
 subtype Drum_Ref is Peripheral_Ref(Drum);
 type Message_Procedure is access procedure (M : in     String := "Error!");
 type Cell;-- incomplete type declaration
 type Link is access Cell;
 type Cell is
 record
    Value : Integer;
    Succ  : Link;
    Pred  : Link;
 end record;
 type Person(<>);-- incomplete type declaration
 type Car;-- incomplete type declaration
 type Person_Name is access Person;
 type Car_Name is access all Car;
 type Car is
 record
    Number : Integer;
    Owner  : Person_Name;
 end record;
 type Person(Sex : Gender) is
 record
    Name    : String(1 .. 20);
    Birth   : Date;
    Age     : Integer range 0 .. 130;
    Vehicle : Car_Name;
    case Sex is
       when M                    =>
       Wife : Person_Name(Sex    => F);
       when F                    =>
       Husband : Person_Name(Sex => M);
    end case;
 end record;
 type Operations_On_Entity_Type(Which_Entity : Entity_Kind_Type := Object)
 is
 record
    case Which_Entity
       is
       when Object
       | Parameter
       | Constant_Parameter
       | Enumeration_Type
       | Is_A_Type
       | Is_A_Subtype => Operation_On_Object : Operation_On_Object_Type := View_Declared_In;
       when File
       | File_Name =>
       Operation_On_File : Operation_On_File_Type := View_Content;
       when Procedure_Spec
       | Procedure_Body
       | Procedure_Call
       | Package_Spec
       | Package_Body
       | Function_Body
       | Function_Call
       | Function_Spec
       | Renamed_Proc
       | Renamed_Func => Operation_On_Routine : Operation_On_Routine_Type := View_File_From;
       when Access_Type
       | Private_Type
       | Array_Type
       | Exception_Type
       | Record_Type => Operation_On_Declaration : Operation_On_Declaration_Type := View_Declared_In;
       when Instantiated_Package
       | Instantiated_Generic
       | Nested_Package_Spec
       | Nested_Package_Body
       | Nested_Function_Spec
       | Nested_Function_Body
       | Nested_Procedure_Spec
       | Nested_Procedure_Body => Operation_On_Package : Operation_On_Package_Type := View_File_From;
       when Top_Level_Function_Body
       | Top_Level_Function_Spec
       | Top_Level_Procedure_Body
       | Top_Level_Procedure_Spec
       | Top_Level_Package_Body
       | Top_Level_Package_Spec => Operation_On_Top_Level : Operation_On_Top_Level_Type := View_Declared_In;
    end case;
 end record;
    task type Automatic_Backup_Task_Type
    is
    entry Start;
    end Automatic_Backup_Task_Type;
 
 for Automatic_Backup_Task_Type'Storage_Size use 128 * 1024;--12
 begin
 null;
 end Dic_Ext;
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
