 --
 --
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEEEEEEE
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    P          P    A          A    R          R    S              E
 --    PPPPPPPPPPPP    AAAAAAAAAAAA    RRRRRRRRRRRR    SSSSSSSSSSS    EEEEEEE
 --    P               A          A    R R                       S    E
 --    P               A          A    R  R                      S    E
 --    P               A          A    R   R                     S    E
 --    P               A          A    R     R                   S    E
 --    P               A          A    R       R                 S    E
 --    P               A          A    R         R     SSSSSSSSSSS    EEEEEEEEEEEE
 --
 --
 --
 --
 --     Copyright (C)  2002  Daniel Gaudry (Daniel.Gaudry@wanadoo.fr)
 --     9 av calmels
 --     92270 bois colombes  france
 --     Home +33147862334
 --     Cell +33664195009
 --     Work +33148575063
 --     Fax  +33148571106
 --
 --     This library is free software; you can redistribute it and/or
 --     modify it under the terms of the GNU Library General Public
 --     License as published by the Free Software Foundation; either
 --     version 2 of the License, or (at your option) any later version.
 --
 --     This library is distributed in the hope that it will be useful,
 --     but WITHOUT ANY WARRANTY; without even the implied warranty of
 --     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 --     Library General Public License for more details.
 --
 --     You should have received a copy of the GNU Library General Public
 --     License along with this library; if not, write to the Free
 --     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 --     MA 02111-1307, USA
 --
 -- Version 1.00 March 7 th, 2002
 --
 --
 --
 --
 --
 
 
 with Name_Test;
 with Ada.Text_Io;
 with Ada.Finalization;
 
 package body Gram
 is
 --Identifier     : constant String := "@";
 --Number         : constant String := ";
 --Char_Or_String : constant String := "";
 --
 --|
 --|              ||
 --|              | Set_Error_Message                              |
 --|              |________________________________________________|
 --|
    procedure Set_Error_Message(To : in     String)
    is
    begin
    if not Error_Message.Error_Found
       then
       Error_Message := (Error_Found          => True,
                         Line_Number          => Rt.Current_Line_Number,
                         Character_Position   => Long_Integer(Rt.Current_Token_Position),
                         Error_Message_Access => new String'(To));
    end if;
    end Set_Error_Message;
 --|
 --|              ||
 --|              | A_Name                                         |
 --|              |________________________________________________|
 --|
 
 -- id {. id}| id.string |id{'id} | string
    function A_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("A_Name " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = Rt.Char_Or_String
       then
       Rt.Read(Current_Code_State);
       Rt.Trace("A_Name Char_Or_String returns TRUE " & Rt.Current(Current_Code_State).all);
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("A_Name returns FALSE " & Rt.Current(Current_Code_State).all);
       Rt.Trace(Rt.Print(Current_Code_State));
       return False;
    end if;
    for I in 1 .. 50 loop
       if Rt.Current(Current_Code_State).all = "."
          or else Rt.Current(Current_Code_State).all = "'"
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if Rt.Current(Current_Code_State).all = Rt.Identifier
          or else (I = 1 and then Rt.Current(Current_Code_State).all = Rt.Char_Or_String)
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("A_Name returns FALSE " & Rt.Current(Current_Code_State).all);
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
    end loop;
    Rt.Trace("A_Name returns true " & Rt.Current(Current_Code_State).all);
    Rt.Trace(Rt.Print(Current_Code_State));
    return True;
    end A_Name;
 --|
 --|              ||
 --|              |EXPRESSION_A    |
 --|              |________________|
 --|
    function Expression_A
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Bool               : Boolean;
    begin
    Rt.Trace("EXPRESSION_A");
    Rt.Trace(Rt.Print(Current_Code_State));
    Name_Test.Test_Name(Code_State => Current_Code_State,
                        Ok         => Bool);
    if not Bool
       then
       Current_Code_State := Code_State_In_Test;
    end if;
    Rt.Trace("EXPRESSION_A exiting >"
             & Rt.Current(Current_Code_State).all
             & "< bool "
             & Boolean'Image(Bool)
             & "   "
             & Rt.Current_Line);
    Rt.Trace(Rt.Print(Current_Code_State));
    return Bool;
    end Expression_A;
 --|
 --|              ||
 --|              |Expression_B    |
 --|              |________________|
 --|
    function Expression_B
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Bool               : Boolean;
    begin
    Rt.Trace("EXPRESSION_B");
    Rt.Trace(Rt.Print(Current_Code_State));
    Name_Test.Test_Name(Code_State                 => Current_Code_State,
                        Ok                         => Bool,
                        Skip_Last_Left_Parenthesis => True);
    if not Bool
       then
       Current_Code_State := Code_State_In_Test;
    end if;
    Rt.Trace("EXPRESSION_B exiting >"
             & Rt.Current(Current_Code_State).all
             & "< bool "
             & Boolean'Image(Bool)
             & "   "
             & Rt.Current_Line);
    Rt.Trace(Rt.Print(Current_Code_State));
    return Bool;
    end Expression_B;
 --|
 --|              ||
 --|              |            Character_Literal                   |
 --|              |________________________________________________|
 --|
 --2.5:
 
 --character_literal ::= 'graphic_character'
    function Character_Literal
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Current_Code_State := Current_Code_State;
    if Rt.Current(Current_Code_State).all = Rt.Char_Or_String
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Character_Literal;
 --|
 --|              ||
 --|              |            String_Literal                      |
 --|              |________________________________________________|
 --|
 --2.6:
 
 --string_literal ::= "{ string_element }"
    function String_Literal
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("String_Literal");
    if Rt.Current(Current_Code_State).all = Rt.Char_Or_String
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end String_Literal;
 --|
 --|              ||
 --|              |            Pragma_X                            |
 --|              |________________________________________________|
 --|
 --2.8:
 --pragma ::=
 --pragma identifier [(pragma_argument_association { , pragma_argument_association })];
    function Pragma_X
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Pragma_X");
    if Rt.Current(Current_Code_State).all = "pragma"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Pragma_X returns false A");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "@"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Pragma_X returns false B");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Pragma_Argument_Association
          then
          Rt.Trace("Pragma_X returns false C");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       loop
          if Rt.Current(Current_Code_State).all = ","
             then
             Rt.Read(Current_Code_State);
             else
             exit;
          end if;
          if not Pragma_Argument_Association
             then
             Rt.Trace("Pragma_X returns false D");
             Current_Code_State := Code_State_In_Test;
             return False;
          end if;
       end loop;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Rt.Trace("Pragma_X returns false E");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Pragma_X returns false F");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Pragma_X returns true ");
    return True;
    end Pragma_X;
 --|
 --|              ||
 --|              | Pragma_Argument_Association                    |
 --|              |________________________________________________|
 --|
 --2.8:
 --pragma_argument_association ::=
 --[pragma_argument_identifier =>] name
 --|[pragma_argument_identifier =>] expression
    function Pragma_Argument_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Pragma_Argument_Association");
    if Rt.Current(Current_Code_State).all = "@"
       and then Rt.Next(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
    end if;
    return Expression_B or else A_Name;
    end Pragma_Argument_Association;
 --|
 --|              ||
 --|              | Basic_Declaration                              |
 --|              |________________________________________________|
 --|
 
 --3.1:
 --basic_declaration ::=
 --type_declaration|subtype_declaration
 --|object_declaration|number_declaration
 --|subprogram_declaration|abstract_subprogram_declaration
 --|package_declaration|renaming_declaration
 --|exception_declaration|generic_declaration
 --|generic_instantiation
    function Basic_Declaration
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Basic_Declaration" & Rt.Current(Current_Code_State).all);
    Rt.Trace(Rt.Print(Current_Code_State));
    Result := Type_Declaration
    or else Subtype_Declaration
    or else Object_Declaration
    or else Number_Declaration
    or else Subprogram_Declaration
    or else Abstract_Subprogram_Declaration
    or else Package_Declaration
    or else Renaming_Declaration
    or else Exception_Declaration
    or else Generic_Declaration
    or else Generic_Instantiation
    or else Pragma_X;
    Rt.Trace("Basic_Declaration " & Boolean'Image(Result));
    return Result;
    end Basic_Declaration;
 --3.1:
 --defining_identifier ::= identifier
 --|
 --|              ||
 --|              | Type_Declaration                               |
 --|              |________________________________________________|
 --|
 
 --3.2.1:
 --Type_Declaration ::=  full_type_declaration
 --|incomplete_type_declaration
 --|private_type_declaration
 --|private_extension_declaration
 
    function Type_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("Type_Declaration");
    Rt.Trace(Rt.Print(Current_Code_State));
    Result := Full_Type_Declaration
    or else Incomplete_Type_Declaration
    or else Private_Type_Declaration
    or else Private_Extension_Declaration;
    Rt.Trace("Type_Declaration returns " & Boolean'Image(Result));
    return Result;
    end Type_Declaration;
 --|
 --|              ||
 --|              | Full_Type_Declaration                          |
 --|              |________________________________________________|
 --|
 
 --3.2.1:
 
 --full_type_declaration ::=
 --type defining_identifier [known_discriminant_part] is type_definition;
 --|task_type_declaration
 --|protected_type_declaration
    function Full_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Full_Type_Declaration");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = Rt.Identifier
          then
          Rt.Read(Current_Code_State);
          else
          Rt.Trace(Rt.Print(Current_Code_State));
          Rt.Trace("Full_Type_Declaration A");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Dummy := Known_Discriminant_Part;
       if Rt.Current(Current_Code_State).all = "is"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Full_Type_Declaration B");
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
       if not Type_Definition
          then
          Rt.Trace("Full_Type_Declaration C");
          Current_Code_State := Code_State_In_Test;
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
       Rt.Trace(Rt.Print(Current_Code_State));
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          Rt.Trace("Full_Type_Declaration D");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
       elsif Task_Type_Declaration
       then
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
       elsif Protected_Type_Declaration
       then
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    end Full_Type_Declaration;
 --|
 --|              ||
 --|              |                Type_Definition                 |
 --|              |________________________________________________|
 --|
 --3.2.1:
 
 --type_definition ::=
 --enumeration_type_definition|integer_type_definition
 --|real_type_definition|array_type_definition
 --|record_type_definition|access_type_definition
 --|derived_type_definition
    function Type_Definition
    return Boolean
    is
    Test               : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Type_Definition");
    Rt.Trace(Rt.Print(Current_Code_State));
    Test := Enumeration_Type_Definition
    or else Integer_Type_Definition
    or else Real_Type_Definition
    or else Array_Type_Definition
    or else Record_Type_Definition
    or else Access_Type_Definition
    or else Derived_Type_Definition;
    Rt.Trace("Type_Definition  returns " & Boolean'Image(Test));
    Rt.Trace(Rt.Print(Current_Code_State));
    return Test;
    end Type_Definition;
 --|
 --|              ||
 --|              |            Subtype_Declaration                 |
 --|              |________________________________________________|
 --|
 --3.2.2:
 
 --subtype_declaration ::=
 --subtype defining_identifier is subtype_indication;
    function Subtype_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subtype_Declaration");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "subtype"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Subtype_Declaration missing is");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Subtype_Indication
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Semicolon Subtype_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Subtype_Declaration;
 --|
 --|              ||
 --|              | subtype_indication                             |
 --|              |________________________________________________|
 --|
 --3.2.2:
 --subtype_indication ::=  subtype_mark [constraint]
    function Subtype_Indication
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subtype_Indication");
    Rt.Trace(Rt.Print(Current_Code_State));
    if not (Function_Call or else A_Name) -- !!!!
       then
       Rt.Trace("Subtype_Indication FALSE");
       return False;
    end if;
    Dummy := Constraint;
    Rt.Trace("Subtype_Indication ok");
    Rt.Trace(Rt.Print(Current_Code_State));
    return True;
    end Subtype_Indication;
 --3.2.2:
 --subtype_mark ::= subtype_name
 --|
 --|              ||
 --|              | Constraint                                     |
 --|              |________________________________________________|
 --|
 
 --3.2.2:
 --constraint ::= scalar_constraint | composite_constraint
 
    function Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Constraint");
    Rt.Trace(Rt.Print(Current_Code_State));
    return Scalar_Constraint or else Composite_Constraint;
    end Constraint;
 --|
 --|              ||
 --|              | Scalar_Constraint                              |
 --|              |________________________________________________|
 --|
 
 --3.2.2
 --scalar_constraint ::=
 --range_constraint | digits_constraint | delta_constraint
    function Scalar_Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Scalar_Constraint");
    return Range_Constraint or else Digits_Constraint or else Delta_Constraint;
    end Scalar_Constraint;
 --|                       R
 --|              ||
 --|              | Composite_Constraint                           |
 --|              |________________________________________________|
 --|
 
 --3.2.2:
 --composite_constraint ::=
 --index_constraint | discriminant_constraint
 
    function Composite_Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Composite_Constraint");
    return Index_Constraint or else Discriminant_Constraint;
    end Composite_Constraint;
 --|
 --|              ||
 --|              | Object_Declaration                             |
 --|              |________________________________________________|
 --|
 
 --3.3.1:
 --object_declaration ::=
 --defining_identifier_list : [aliased] [constant] subtype_indication [:= expression];
 --|defining_identifier_list : [aliased] [constant] array_type_definition [:= expression];
 --|single_task_declaration
 --|single_protected_declaration
 
    function Object_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("object_declaration " & Rt.Current(Current_Code_State).all);
    Rt.Trace(Rt.Print(Current_Code_State));
    if Defining_Identifier_List
       then
       if Rt.Current(Current_Code_State).all = ":"
          then
          Rt.Read(Current_Code_State);
          else
          Rt.Trace("object_declaration returns FALSE  A");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Rt.Trace("object_declaration :  found");
       Rt.Trace(Rt.Print(Current_Code_State));
       if Rt.Current(Current_Code_State).all = "aliased"
          then
          Rt.Read(Current_Code_State);
       end if;
       if Rt.Current(Current_Code_State).all = "constant"
          then
          Rt.Read(Current_Code_State);
       end if;
       if not (Subtype_Indication or else Array_Type_Definition)
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("object_declaration returns FALSE  B");
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ":="
          then
          Rt.Read(Current_Code_State);
          Rt.Trace("object_declaration := found");
          Rt.Trace(Rt.Print(Current_Code_State));
          if not Expression_A --Expression
             then
             Current_Code_State := Code_State_In_Test;
             Rt.Trace("object_declaration returns FALSE  C");
             return False;
          end if;
          Rt.Trace("EXPRESSION_A ok");
          Rt.Trace(Rt.Print(Current_Code_State));
       end if;
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("object_declaration returns FALSE  D");
          return False;
       end if;
       Rt.Trace("object_declaration ; found return true");
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
       elsif Single_Task_Declaration
       then
       Rt.Trace("object_declaration returns TRUE  ");
       return True;
       elsif Single_Protected_Declaration
       then
       Rt.Trace("object_declaration returns TRUE  after Single_Protected_Declaration");
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    Rt.Trace("object_declaration returns FALSE E");
    return False;
    end Object_Declaration;
 --|
 --|              ||
 --|              | Defining_Identifier_List                       |
 --|              |________________________________________________|
 --|
 
 --3.3.1:
 --defining_identifier_list ::=
 --defining_identifier { , defining_identifier }
 
    function Defining_Identifier_List
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Defining_Identifier_List");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Defining_Identifier_List returns false");
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= ",";
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = Rt.Identifier
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Defining_Identifier_List returns false");
          return False;
       end if;
    end loop;
    Rt.Trace("Defining_Identifier_List returns true");
    return True;
    end Defining_Identifier_List;
 --|
 --|              ||
 --|              | Number_Declaration                             |
 --|              |________________________________________________|
 --|
 
 --3.3.2:
 --number_declaration ::=
 --defining_identifier_list : constant := static_expression;
 
    function Number_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Number_Declaration");
    Rt.Trace(Rt.Print(Current_Code_State));
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "constant"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A --
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Number_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Number_Declaration;
 --|
 --|              ||
 --|              |        Derived_Type_Definition                 |
 --|              |________________________________________________|
 --|
 --3.4:
 
 --derived_type_definition ::= [abstract] new parent_subtype_indication [record_extension_part]
    function Derived_Type_Definition
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Derived_Type_Definition" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "new"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Derived_Type_Definition false");
       return False;
    end if;
    if not Subtype_Indication --^^
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Derived_Type_Definition false");
       return False;
    end if;
    Dummy := Record_Extension_Part;
    Rt.Trace("Derived_Type_Definition true");
    return True;
    end Derived_Type_Definition;
 --|
 --|              ||
 --|              |               Range_Constraint                 |
 --|              |________________________________________________|
 --|
 --3.5:
 
 --range_constraint ::=  range range
    function Range_Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Range_Constraint");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return Expression_B;--240502
    end Range_Constraint;
 --|
 --|              ||
 --|              |                  Range_X                       |
 --|              |________________________________________________|
 --|
 --3.5:
 --range ::=  range_attribute_reference
 --|simple_expression .. simple_expression
    function Range_X
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Range_X");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Range_Attribute_Reference
       then
       Rt.Trace("Range_x  true A");
       return True;
    end if;
    if not Expression_B
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Range_X false");
       return False;
    end if;
 
    if Rt.Current(Current_Code_State).all = "range"--240502
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Range_X false");
       Rt.Trace(Rt.Print(Current_Code_State));
       return False;
       else
       Rt.Trace("Range_X true b");
       Rt.Trace(Rt.Print(Current_Code_State));
       return True;
    end if;
    end Range_X;
 --|
 --|              ||
 --|              |          Enumeration_Type_Definition           |
 --|              |________________________________________________|
 --|
 --3.5.1:
 
 --enumeration_type_definition ::=
 --(enumeration_literal_specification { , enumeration_literal_specification })
    function Enumeration_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Enumeration_Type_Definition");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Enumeration_Literal_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          exit;
       end if;
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not Enumeration_Literal_Specification
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Enumeration_Type_Definition;
 --|
 --|              ||
 --|              |      Enumeration_Literal_Specification         |
 --|              |________________________________________________|
 --|
 --3.5.1:  --^^
 
 --enumeration_literal_specification ::=  defining_identifier | defining_character_literal
    function Enumeration_Literal_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Enumeration_Literal_Specification");
    if Rt.Current(Current_Code_State).all = "@"
       then
       Rt.Read(Current_Code_State);
       return True;
       elsif not Defining_Character_Literal
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Enumeration_Literal_Specification;
 --|
 --|              ||
 --|              |       Defining_Character_Literal               |
 --|              |________________________________________________|
 --|
 --3.5.1:
 
 --defining_character_literal ::= character_literal
    function Defining_Character_Literal
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Defining_Character_Literal");
    Current_Code_State := Code_State_In_Test;
    if Rt.Current(Current_Code_State).all = Rt.Char_Or_String
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Defining_Character_Literal;
 --|
 --|              ||
 --|              |            integer_type_definition             |
 --|              |________________________________________________|
 --|
 --3.5.4:
 
 --integer_type_definition ::= signed_integer_type_definition | modular_type_definition
    function Integer_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Integer_Type_Definition");
    return Signed_Integer_Type_Definition or else Modular_Type_Definition;
    end Integer_Type_Definition;
 --|
 --|              ||
 --|              |        Signed_Integer_Type_Definition          |
 --|              |________________________________________________|
 --|
 --3.5.4:
 
 --signed_integer_type_definition ::= range static_simple_expression .. static_simple_expression
    function Signed_Integer_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Signed_Integer_Type_Definition");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;--^^
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Signed_Integer_Type_Definition;
 --|
 --|              ||
 --|              |           Modular_Type_Definition              |
 --|              |________________________________________________|
 --|
 --3.5.4:
 --modular_type_definition ::= mod static_expression
    function Modular_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Modular_Type_Definition");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "mod"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A -- Simple_Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Modular_Type_Definition;
 --|
 --|              ||
 --|              |              Real_Type_Definition              |
 --|              |________________________________________________|
 --|
 --3.5.6:
 
 --real_type_definition ::=
 --floating_point_definition | fixed_point_definition
    function Real_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Real_Type_Definition");
    return Floating_Point_Definition or else Fixed_Point_Definition;
    end Real_Type_Definition;
 --|
 --|              ||
 --|              |       Floating_Point_Definition                |
 --|              |________________________________________________|
 --|
 --3.5.7:
 
 --floating_point_definition ::=
 --digits static_expression [real_range_specification]
    function Floating_Point_Definition
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Floating_Point_Definition");
    if Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Real_Range_Specification;
    return True;
    end Floating_Point_Definition;
 --|
 --|              ||
 --|              |          Real_Range_Specification              |
 --|              |________________________________________________|
 --|
 --3.5.7:
 
 --real_range_specification ::=
 --range static_simple_expression .. static_simple_expression
    function Real_Range_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Real_Range_Specification");
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Real_Range_Specification;
 --|
 --|              ||
 --|              |              Fixed_Point_Definition            |
 --|              |________________________________________________|
 --|
 --3.5.9:
 
 --fixed_point_definition ::= ordinary_fixed_point_definition | decimal_fixed_point_definition
    function Fixed_Point_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Fixed_Point_Definition");
    return Ordinary_Fixed_Point_Definition or else Decimal_Fixed_Point_Definition;
    end Fixed_Point_Definition;
 --|
 --|              ||
 --|              |      Ordinary_Fixed_Point_Definition           |
 --|              |________________________________________________|
 --|
 --3.5.9:
 
 --ordinary_fixed_point_definition ::=
 --delta static_expression  real_range_specification
    function Ordinary_Fixed_Point_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Ordinary_Fixed_Point_Definition");
    if Rt.Current(Current_Code_State).all = "delta"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Simple_Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Real_Range_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
 
    return True;
    end Ordinary_Fixed_Point_Definition;
 --|
 --|              ||
 --|              |         Decimal_Fixed_Point_Definition         |
 --|              |________________________________________________|
 --|
 --3.5.9:
 
 --decimal_fixed_point_definition ::=
 --delta static_expression digits static_expression [real_range_specification]
    function Decimal_Fixed_Point_Definition
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Decimal_Fixed_Point_Definition");
 
    if Rt.Current(Current_Code_State).all = "delta"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Simple_Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Simple_Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Real_Range_Specification;
    return True;
    end Decimal_Fixed_Point_Definition;
 --|
 --|              ||
 --|              |            Digits_Constraint                   |
 --|              |________________________________________________|
 --|
 --3.5.9:
 
 --digits_constraint ::=
 --digits static_expression [range_constraint]
    function Digits_Constraint
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Digits_Constraint");
    if Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Range_Constraint;
    return True;
    end Digits_Constraint;
 --|
 --|              ||
 --|              |            Array_Type_Definition               |
 --|              |________________________________________________|
 --|
 
 --3.6:
 
 --array_type_definition ::=
 --unconstrained_array_definition | constrained_array_definition
    function Array_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Array_Type_Definition");
    return Unconstrained_Array_Definition or else Constrained_Array_Definition;
    end Array_Type_Definition;
 --|
 --|              ||
 --|              |    Unconstrained_Array_Definition              |
 --|              |________________________________________________|
 --|
 --3.6:
 
 --unconstrained_array_definition ::=
 --array(index_subtype_definition {, index_subtype_definition }) of component_definition
    function Unconstrained_Array_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Unconstrained_Array_Definition");
    if Rt.Current(Current_Code_State).all = "array"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  A");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  B");
       return False;
    end if;
    if not Index_Subtype_Definition
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  C");
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Index_Subtype_Definition
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Unconstrained_Array_Definition returns false  D");
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  E");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "of"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  F");
       return False;
    end if;
    if not Component_Definition
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Unconstrained_Array_Definition returns false  F");
       return False;
    end if;
    Rt.Trace("Unconstrained_Array_Definition returns TRUE");
    return True;
    end Unconstrained_Array_Definition;
 --|
 --|              ||
 --|              |        Index_Subtype_Definition                |
 --|              |________________________________________________|
 --|
 --3.6:
 
 --index_subtype_definition ::= subtype_mark range <>
    function Index_Subtype_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Index_Subtype_Definition");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Index_Subtype_Definition;
 --|
 --|              ||
 --|              |         Constrained_Array_Definition           |
 --|              |________________________________________________|
 --|
 --3.6:
 
 --constrained_array_definition ::=
 --array (discrete_subtype_definition { , discrete_subtype_definition }) of component_definition
    function Constrained_Array_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Constrained_Array_Definition");
    if Rt.Current(Current_Code_State).all = "array"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false A");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false B");
       return False;
    end if;
    if not Discrete_Subtype_Definition
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false C");
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Discrete_Subtype_Definition
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Constrained_Array_Definition returns false D");
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false E");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "of"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false F");
       return False;
    end if;
    if not Component_Definition
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Constrained_Array_Definition returns false G");
       return False;
    end if;
    Rt.Trace("Constrained_Array_Definition returns true");
    return True;
    end Constrained_Array_Definition;
 --|
 --|              ||
 --|              |            Discrete_Subtype_Definition         |
 --|              |________________________________________________|
 --|
 --3.6:
 
 --discrete_subtype_definition ::= discrete_subtype_indication | range
    function Discrete_Subtype_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discrete_Subtype_Definition");
    return Range_X or else Subtype_Indication;
    end Discrete_Subtype_Definition;
 --|
 --|              ||
 --|              |          Component_Definition                  |
 --|              |________________________________________________|
 --|
 --3.6:
 
 --component_definition ::= [aliased] subtype_indication
    function Component_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_Definition");
    if Rt.Current(Current_Code_State).all = "aliased"
       then
       Rt.Read(Current_Code_State);
    end if;
    if not Subtype_Indication
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Component_Definition;
 --|
 --|              ||
 --|              |         Index_Constraint                       |
 --|              |________________________________________________|
 --|
 --3.6.1:
 
 --index_constraint ::=  (discrete_range { , discrete_range })
    function Index_Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Index_Constraint");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discrete_Range
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Discrete_Range
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Index_Constraint;
 --|
 --|              ||
 --|              | Discrete_Range                            |
 --|              |___________________________________________|
 --|
 
 --3.6.1:
 --discrete_range ::= discrete_subtype_indication | range
 
    function Discrete_Range
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discrete_Range");
    return Range_X or else Subtype_Indication;
    end Discrete_Range;
 --|
 --|              ||
 --|              |                Discriminant_Part               |
 --|              |________________________________________________|
 --|
 --3.7:
 
 --discriminant_part ::= unknown_discriminant_part | known_discriminant_part
    function Discriminant_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discriminant_Part");
    return Unknown_Discriminant_Part or else Known_Discriminant_Part;
    end Discriminant_Part;
 --|
 --|              ||
 --|              |      Unknown_Discriminant_Part                 |
 --|              |________________________________________________|
 --|
 --3.7:
 
 --unknown_discriminant_part ::= (<>)
    function Unknown_Discriminant_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Unknown_Discriminant_Part");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Unknown_Discriminant_Part;
 --|
 --|              ||
 --|              |      Known_Discriminant_Part                   |
 --|              |________________________________________________|
 --|
 --3.7:
 
 --known_discriminant_part ::=
 --(discriminant_specification { ; discriminant_specification })
    function Known_Discriminant_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Known_Discriminant_Part");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Known_Discriminant_Part A " & Rt.Current(Current_Code_State).all);
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discriminant_Specification
       then
       Rt.Trace("Known_Discriminant_Part B " & Rt.Current(Current_Code_State).all);
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Discriminant_Specification
          then
          Rt.Trace("Known_Discriminant_Part C " & Rt.Current(Current_Code_State).all);
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Known_Discriminant_Part D " & Rt.Current(Current_Code_State).all);
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Known_Discriminant_Part TRUE " & Rt.Current(Current_Code_State).all);
    return True;
    end Known_Discriminant_Part;
 --|
 --|              ||
 --|              |     Discriminant_Specification                 |
 --|              |________________________________________________|
 --|
 --3.7:
 
 --discriminant_specification ::=
 --defining_identifier_list : subtype_mark [:= default_expression]
 --|defining_identifier_list : access_definition [:= default_expression]
    function Discriminant_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discriminant_Specification");
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not (A_Name or else Access_Definition)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       if not Expression_B
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Discriminant_Specification;
 --|
 --|              ||
 --|              |         Default_Expression                     |
 --|              |________________________________________________|
 --|
 --3.7:
 
 --default_expression ::= expression
    function Default_Expression
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Default_Expression");
    return Expression;
    end Default_Expression;
 --|
 --|              ||
 --|              |         Discriminant_Constraint                |
 --|              |________________________________________________|
 --|
 --3.7.1:
 
 --discriminant_constraint ::=
 --(discriminant_association { , discriminant_association })
    function Discriminant_Constraint
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discriminant_Constraint");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discriminant_Association
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Discriminant_Association
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Discriminant_Constraint;
 --|
 --|              ||
 --|              |          Discriminant_Association              |
 --|              |________________________________________________|
 --|
 --3.7.1:
 
 --discriminant_association ::=
 --[discriminant_selector_name { | discriminant_selector_name } =>] expression
    function Discriminant_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discriminant_Association");
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       loop
          if Rt.Current(Current_Code_State).all = "|"
             then
             Rt.Read(Current_Code_State);
             else
             exit;
          end if;
          if Rt.Current(Current_Code_State).all = Rt.Identifier
             then
             Rt.Read(Current_Code_State);
             else
             Current_Code_State := Code_State_In_Test;
             return False;
          end if;
       end loop;
       if Rt.Current(Current_Code_State).all = "=>"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if not Expression_B
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Discriminant_Association;
 --|
 --|              ||
 --|              |       Record_Type_Definition                   |
 --|              |________________________________________________|
 --|
 --3.8:
 
 --record_type_definition ::= [[abstract] tagged] [limited] record_definition
    function Record_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Type_Definition");
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "tagged"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "limited"
       then
       Rt.Read(Current_Code_State);
    end if;
    if not Record_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Record_Type_Definition;
 --|
 --|              ||
 --|              |          Record_Definition                     |
 --|              |________________________________________________|
 --|
 --3.8:
 
 --record_definition ::=
 --record
 --component_list
 --end record
 --|null record
    function Record_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Definition");
    if Rt.Current(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       elsif Rt.Current(Current_Code_State).all = "null"
       and then Rt.Next(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
       return True;
       else
       Rt.Trace("Record_Definition A");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Component_List
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Record_Definition B");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Record_Definition C");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Record_Definition D");
       return False;
    end if;
    return True;
    end Record_Definition;
 --|
 --|              ||
 --|              |         Component_List                         |
 --|              |________________________________________________|
 --|
 --3.8:
 
 --component_list ::=
 --component_item { component_item }
 --| { component_item } variant_part
 --|null;
    function Component_List
    return Boolean
    is
    At_Least_One_Component_Item : Boolean;
    Code_State_In_Test          : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_List");
    At_Least_One_Component_Item := False;
    if Rt.Current(Current_Code_State).all = "null"
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          Rt.Trace("Component_List A returns true");
          return True;
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Component_List B returns false");
          return False;
       end if;
    end if;
    loop
       exit when not Component_Item;
       At_Least_One_Component_Item := True;
    end loop;
    if Variant_Part or else At_Least_One_Component_Item
       then
       Rt.Trace("Component_List C returns true");
       return True;
       else
       Set_Error_Message(To => "Component_Item or Variant_Part Missing");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Component_List  D returns false");
       return False;
    end if;
    end Component_List;
 --|
 --|              ||
 --|              |              Component_Item                    |
 --|              |________________________________________________|
 --|
 --3.8:
 
 --component_item ::= component_declaration | representation_clause
    function Component_Item
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_Item");
    return Component_Declaration or else Representation_Clause;
    end Component_Item;
 --|
 --|              ||
 --|              |           Component_Declaration                |
 --|              |________________________________________________|
 --|
 --3.8:
 
 --component_declaration ::=
 --defining_identifier_list : component_definition [:= default_expression];
    function Component_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_Declaration");
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Component_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Component_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
 
    end Component_Declaration;
 --|
 --|              ||
 --|              |            Variant_Part                        |
 --|              |________________________________________________|
 --|
 --3.8.1:
 
 --variant_part ::=
 --case discriminant_direct_name is
 --variant
 --{ variant }
 --end case;
    function Variant_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Variant_Part case " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "case"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Variant_Part A");
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Variant_Part B");
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Variant_Part C");
    if not Variant
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Variant;
    end loop;
    Rt.Trace("Variant_Part  end " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Variant_Part  case " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "case"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Variant_Part  ; " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Variant_Part");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Variant_Part;
 --|
 --|              ||
 --|              |             Variant                            |
 --|              |________________________________________________|
 --|
 --3.8.1:
 
 --variant ::=
 --when discrete_choice_list =>
 --component_list
    function Variant
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Variant");
    if Rt.Current(Current_Code_State).all = "when"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discrete_Choice_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Component_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Variant;
 --|
 --|              ||
 --|              | Discrete_Choice_List                      |
 --|              |___________________________________________|
 --|
 
 --3.8.1:
 --discrete_choice_list ::= discrete_choice { | discrete_choice }
 
    function Discrete_Choice_List
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discrete_Choice_List");
    if not Discrete_Choice
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= "|";
       Rt.Read(Current_Code_State);
       if not Discrete_Choice
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Discrete_Choice_List;
 --|
 --|              ||
 --|              | Discrete_Choice                           |
 --|              |___________________________________________|
 --|
 
 --3.8.1:
 --discrete_choice ::= expression | discrete_range | others
 
    function Discrete_Choice
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Discrete_Choice");
    if Rt.Current(Current_Code_State).all = "others"
       then
       Rt.Read(Current_Code_State);
       Dummy := True;
       else
       Dummy := False;
    end if;
    if not (Expression or else Discrete_Range or else Dummy)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Discrete_Choice;
 --|
 --|              ||
 --|              |       Record_Extension_Part                    |
 --|              |________________________________________________|
 --|
 --3.9.1:
 
 --record_extension_part ::= with record_definition
    function Record_Extension_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Extension_Part");
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return Record_Definition;
    end Record_Extension_Part;
 --|
 --|              ||
 --|              |          Access_Type_Definition                |
 --|              |________________________________________________|
 --|
 --3.10:
 
 --access_type_definition ::=
 --access_to_object_definition
 --|access_to_subprogram_definition
    function Access_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Access_Type_Definition");
    return Access_To_Object_Definition or else Access_To_Subprogram_Definition;
 
    end Access_Type_Definition;
 --|
 --|              ||
 --|              |        Access_To_Object_Definition             |
 --|              |________________________________________________|
 --|
 --3.10:
 
 --access_to_object_definition ::=
 --access [general_access_modifier] subtype_indication
    function Access_To_Object_Definition
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Access_To_Object_Definition");
    if Rt.Current(Current_Code_State).all = "access"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := General_Access_Modifier;
    if not Subtype_Indication
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Access_To_Object_Definition;
 --|
 --|              ||
 --|              |        General_Access_Modifier                 |
 --|              |________________________________________________|
 --|
 --3.10:
 
 --general_access_modifier ::= all | constant
    function General_Access_Modifier
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("General_Access_Modifier");
    if Rt.Current(Current_Code_State).all = "all"
       then
       Rt.Read(Current_Code_State);
       Rt.Trace("General_Access_Modifier returns true  A");
       return True;
       elsif Rt.Current(Current_Code_State).all = "constant"
       then
       Rt.Read(Current_Code_State);
       Rt.Trace("General_Access_Modifier returns true  B");
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       --Rt.Read(Current_Code_State);--240502
       Rt.Trace("General_Access_Modifier returns FALSE");
       return False;
    end if;
    end General_Access_Modifier;
 --|
 --|              ||
 --|              |      Access_To_Subprogram_Definition           |
 --|              |________________________________________________|
 --|
 --3.10:
 
 --access_to_subprogram_definition ::=
 --access [protected] procedure parameter_profile
 --|access [protected] function  parameter_and_result_profile
    function Access_To_Subprogram_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Access_To_Subprogram_Definition");
    if Rt.Current(Current_Code_State).all = "access"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "protected"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "procedure"
       then
       Rt.Read(Current_Code_State);
       if not Parameter_Profile
          then
          Current_Code_State := Code_State_In_Test;
          return False;
          else
          return True;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = "function"
       then
       Rt.Read(Current_Code_State);
       if not Parameter_And_Result_Profile
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Access_To_Subprogram_Definition;
 --|
 --|              ||
 --|              |          Access_Definition                     |
 --|              |________________________________________________|
 --|
 --3.10:
 
 --access_definition ::= access subtype_mark
    function Access_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Access_Definition");
    if Rt.Current(Current_Code_State).all = "access"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Access_Definition;
 --|
 --|              ||
 --|              |      Incomplete_Type_Declaration               |
 --|              |________________________________________________|
 --|
 --3.10.1:
 
 --incomplete_type_declaration ::= type defining_identifier [discriminant_part];
    function Incomplete_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Incomplete_Type_Declaration");
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Incomplete_Type_Declaration A");
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Incomplete_Type_Declaration B");
       return False;
    end if;
    Dummy := Discriminant_Part;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Incomplete_Type_Declaration C");
       return False;
    end if;
    Rt.Trace("Incomplete_Type_Declaration returns true");
    return True;
    end Incomplete_Type_Declaration;
 --|
 --|              ||
 --|              | Declarative_Part                          |
 --|              |___________________________________________|
 --|
 
 --3.11:
 --declarative_part ::= { declarative_item }
 
    function Declarative_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Declarative_Part");
    Rt.Trace(Rt.Print(Current_Code_State));
    loop
       exit when not Declarative_Item;
       Rt.Trace("loop Declarative_Part");
       Rt.Trace(Rt.Print(Current_Code_State));
    end loop;
    Rt.Trace("Exiting Declarative_Part");
    Rt.Trace(Rt.Print(Current_Code_State));
    return True;
    end Declarative_Part;
 --|
 --|              ||
 --|              | Declarative_Item                          |
 --|              |___________________________________________|
 --|
 
 --3.11:
 --declarative_item ::=
 --basic_declarative_item | body
    function Declarative_Item
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("Declarative_Item");
    Rt.Trace(Rt.Print(Current_Code_State));
    Result := Basic_Declarative_Item or else Body_X;
    Rt.Trace("Declarative_Item returns " & Boolean'Image(Result));
    return Result;
    end Declarative_Item;
 --|
 --|              ||
 --|              | Basic_Declarative_Item                    |
 --|              |___________________________________________|
 --|
 
 --3.11:
 --basic_declarative_item ::=
 --basic_declaration | representation_clause | use_clause
    function Basic_Declarative_Item
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Basic_Declarative_Item");
    Rt.Trace(Rt.Print(Current_Code_State));
    Result := Basic_Declaration or else Representation_Clause or else Use_Clause or else Pragma_X;
    Rt.Trace("Basic_Declarative_Item returns " & Boolean'Image(Result));
    return Result;
    end Basic_Declarative_Item;
 --|
 --|              ||
 --|              | Body_X                                    |
 --|              |___________________________________________|
 --|
 
 --3.11:
 --body ::= proper_body | body_stub
    function Body_X
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Body_X");
    return Proper_Body or else Body_Stub;
    end Body_X;
 --|
 --|              ||
 --|              | Proper_Body                               |
 --|              |___________________________________________|
 --|
 --3.11:
 
 --proper_body ::=
 --subprogram_body | package_body | task_body | protected_body
    function Proper_Body
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Proper_Body");
    return Subprogram_Body or else Package_Body or else Task_Body or else Protected_Body;
    end Proper_Body;
 
 --|
 --|              ||
 --|              | direct_name    |
 --|              |________________|
 --|
 
 --4.1:
 --direct_name ::= identifier | operator_symbol
    function Direct_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("direct_name");
    if A_Name
       then
       return True;
       elsif Operator_Symbol
       then
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
 
    end Direct_Name;
 --|
 --|              ||
 --|              | Prefix                  |
 --|              |_________________________|
 --|
 
 --4.1:
 --prefix ::= name | implicit_dereference
 
    function Prefix
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Prefix");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Prefix;
 --|
 --|              ||
 --|              | Explicit_Dereference    |
 --|              |_________________________|
 --|
 --4.1:
 --explicit_dereference ::= name.all
 
    function Explicit_Dereference
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Explicit_Dereference");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "."
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "all"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Explicit_Dereference;
 --|
 --|              ||
 --|              | Implicit_Dereference    |
 --|              |_________________________|
 --|
 
 --4.1:
 --implicit_dereference ::= name
 
    function Implicit_Dereference
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Implicit_Dereference");
    return A_Name;
    end Implicit_Dereference;
 --|
 --|              ||
 --|              |          Indexed_Component                     |
 --|              |________________________________________________|
 --|
 --4.1.1:
 
 --indexed_component ::= prefix(expression { , expression })
    function Indexed_Component
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Indexed_Component");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Indexed_Component;
 --|
 --|              ||
 --|              |              Slice                             |
 --|              |________________________________________________|
 --|
 --4.1.2:
 
 --slice ::= prefix(discrete_range)
    function Slice
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Slice");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discrete_Range
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Slice;
 --|
 --|              ||
 --|              |        Selected_Component                      |
 --|              |________________________________________________|
 --|
 --4.1.3:
 
 --selected_component ::= prefix . selector_name
    function Selected_Component
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Selected_Component");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "."
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Selector_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Selected_Component;
 --|
 --|              ||
 --|              |            Selector_Name                       |
 --|              |________________________________________________|
 --|
 --4.1.3:
 
 --selector_name ::= identifier | character_literal | operator_symbol
    function Selector_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Selector_Name");
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       elsif not (Character_Literal or else Operator_Symbol)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Selector_Name;
 --|
 --|              ||
 --|              |         Attribute_Reference                    |
 --|              |________________________________________________|
 --|
 --4.1.4:
 
 --attribute_reference ::= prefix'attribute_designator
    function Attribute_Reference
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Attribute_Reference");
    if A_Name
       and then Rt.Current(Current_Code_State).all = "'"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Attribute_Designator
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Attribute_Reference;
 --|
 --|              ||
 --|              |        Attribute_Designator                    |
 --|              |________________________________________________|
 --|
 --4.1.4:
 
 --attribute_designator ::=
 --identifier[(static_expression)]
 --|Access | Delta | Digits
    function Attribute_Designator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Attribute_Designator");
    if Rt.Current(Current_Code_State).all = "access"
       or else Rt.Current(Current_Code_State).all = "delta"
       or else Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Attribute_Designator;
 --|
 --|              ||
 --|              |        Range_Attribute_Reference               |
 --|              |________________________________________________|
 --|
 --4.1.4:
 
 --range_attribute_reference ::= prefix'range_attribute_designator
    function Range_Attribute_Reference
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Range_Attribute_Reference");
    if not Prefix
       and then Rt.Current(Current_Code_State).all = "'"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Range_Attribute_Designator
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Range_Attribute_Reference;
 --|
 --|              ||
 --|              |          Range_Attribute_Designator            |
 --|              |________________________________________________|
 --|
 --4.1.4:
 
 --range_attribute_designator ::= Range[(static_expression)]
    function Range_Attribute_Designator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Range_Attribute_Designator");
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Range_Attribute_Designator;
 --|
 --|              ||
 --|              |             Aggregate                          |
 --|              |________________________________________________|
 --|
 --4.3:
 
 --aggregate ::= record_aggregate | extension_aggregate | array_aggregate
    function Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Aggregate");
    return Record_Aggregate or else Extension_Aggregate or else Array_Aggregate;
    end Aggregate;
 --|
 --|              ||
 --|              |           Record_Aggregate                     |
 --|              |________________________________________________|
 --|
 --4.3.1:
 
 --record_aggregate ::= (record_component_association_list)
    function Record_Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Aggregate");
 
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Record_Component_Association_List
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Record_Aggregate;
 --|
 --|              ||
 --|              |        Record_Component_Association_List       |
 --|              |________________________________________________|
 --|
 --4.3.1:
 
 --record_component_association_list ::=
 --record_component_association { , record_component_association }
 --|null record
    function Record_Component_Association_List
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Component_Association_List");
    if Rt.Current(Current_Code_State).all = "null"
       and then Rt.Next(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
       return True;
    end if;
    if not Record_Component_Association
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= ",";
       Rt.Read(Current_Code_State);
       if not Record_Component_Association
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Record_Component_Association_List;
 --|
 --|              ||
 --|              |        Record_Component_Association            |
 --|              |________________________________________________|
 --|
 --4.3.1:
 
 --record_component_association ::=
 --[ component_choice_list =>] expression
    function Record_Component_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Component_Association");
    if Component_Choice_List
       then
       if Rt.Current(Current_Code_State).all = "=>"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Record_Component_Association;
 --|
 --|              ||
 --|              |      Component_Choice_List                     |
 --|              |________________________________________________|
 --|
 --4.3.1:
 
 --component_choice_list ::=
 --component_selector_name { | component_selector_name }
 --|others
    function Component_Choice_List
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_Choice_List");
    if Rt.Current(Current_Code_State).all = "others"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= "|";
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Component_Choice_List;
 --|
 --|              ||
 --|              |         Extension_Aggregate                    |
 --|              |________________________________________________|
 --|
 --4.3.2:
 
 --extension_aggregate ::=
 --(ancestor_part with record_component_association_list)
    function Extension_Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Extension_Aggregate");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Ancestor_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Record_Component_Association_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Extension_Aggregate;
 --|
 --|              ||
 --|              |              Ancestor_Part                     |
 --|              |________________________________________________|
 --|
 --4.3.2:
 
 --ancestor_part ::= expression | subtype_mark
    function Ancestor_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Ancestor_Part");
    return Expression or else A_Name;
    end Ancestor_Part;
 --|
 --|              ||
 --|              |               Array_Aggregate                  |
 --|              |________________________________________________|
 --|
 --4.3.3:
 
 --array_aggregate ::=
 --positional_array_aggregate | named_array_aggregate
    function Array_Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Array_Aggregate");
    return Positional_Array_Aggregate or else Named_Array_Aggregate;
    end Array_Aggregate;
 --|
 --|              ||
 --|              |        Positional_Array_Aggregate              |
 --|              |________________________________________________|
 --|
 --4.3.3:
 
 --positional_array_aggregate ::=
 --(expression, expression { , expression })
 --|(expression { , expression }, others => expression)
    function Positional_Array_Aggregate
    return Boolean
    is
 
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Positional_Array_Aggregate");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= ",";
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       elsif Rt.Current(Current_Code_State).all = "others"
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = "=>"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Positional_Array_Aggregate;
 --|
 --|              ||
 --|              |           Named_Array_Aggregate                |
 --|              |________________________________________________|
 --|
 --4.3.3:
 
 --named_array_aggregate ::=
 --(array_component_association { , array_component_association })
    function Named_Array_Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Named_Array_Aggregate");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Array_Component_Association
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Array_Component_Association
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Named_Array_Aggregate;
 --|
 --|              ||
 --|              |           Array_Component_Association          |
 --|              |________________________________________________|
 --|
 --4.3.3:
 
 --array_component_association ::=
 --discrete_choice_list => expression
    function Array_Component_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Array_Component_Association");
    if not Discrete_Choice_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Array_Component_Association;
 --|
 --|              ||
 --|              | Expression                                     |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --expression ::=
 --relation { and relation }|relation { and then relation }
 --|relation { or relation }|relation { or else relation }
 --|relation { xor relation }
 
    function Expression
    return Boolean
    is
    Result : Boolean := False;
 
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Expression");
    Rt.Trace(Rt.Print(Current_Code_State));
    Result := Expression_A;
    Rt.Trace("Expression return " & Boolean'Image(Result));
    Rt.Trace(Rt.Print(Current_Code_State));
    return Result;
    end Expression;
 --|
 --|              ||
 --|              | Relation                                       |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --relation ::=
 --simple_expression [relational_operator simple_expression]
 --|simple_expression [not] in range
 --|simple_expression [not] in subtype_mark
 
    function Relation
    return Boolean
    is
    State              : Integer range 0 .. 6 := 0;
    Code_State_In_Test : Rt.Code_State_Type   := Current_Code_State;
    begin
    Rt.Trace("Relation");
    if Simple_Expression
       then
       State := 1;
    end if;
    if State = 1 and then Relational_Operator
       then
       State := 2;
    end if;
    if State = 2 and then Simple_Expression
       then
       State := 3;
    end if;
    if State = 1 and then Rt.Current(Current_Code_State).all = "not"
       then
       Rt.Read(Current_Code_State);
       State := 4;
    end if;
    if (State = 1 or else State = 4) and then Rt.Current(Current_Code_State).all = "in"
       then
       Rt.Read(Current_Code_State);
       State := 5;
    end if;
    if State = 5 and then Range_X
       then
       State := 6;
    end if;
    if State = 5 and then A_Name
       then
       State := 6;
    end if;
    Rt.Trace("Relation return " & Boolean'Image(State = 1 or else State = 3 or else State = 6));
    return State = 1 or else State = 3 or else State = 6;
    end Relation;
 --|
 --|              ||
 --|              | Simple_Expression                              |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --simple_expression ::= [unary_adding_operator] term { binary_adding_operator term }
 
    function Simple_Expression
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Simple_Expression");
    Dummy := Unary_Adding_Operator;
    if not Term
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Binary_Adding_Operator;
       if not Term
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Simple_Expression;
 --|
 --|              ||
 --|              | Term                                           |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --term ::= factor { multiplying_operator factor }
 
    function Term
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Term");
    if not Factor
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Multiplying_Operator;
       if not Factor
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Term;
 --|
 --|              ||
 --|              | Factor                                         |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --factor ::= primary [** primary] | abs primary | not primary
 
    function Factor
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Factor");
    if Primary
       then
       if Rt.Current(Current_Code_State).all = "**"
          then
          Rt.Read(Current_Code_State);
          return Primary;
       end if;
       elsif Rt.Current(Current_Code_State).all = "abs"
       then
       Rt.Read(Current_Code_State);
       return Primary;
       elsif Rt.Current(Current_Code_State).all = "not"
       then
       Rt.Read(Current_Code_State);
       return Primary;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Factor;
 --|
 --|              ||
 --|              | Primary                                        |
 --|              |________________________________________________|
 --|
 
 --4.4:
 --primary ::=
 --numeric_literal | null | string_literal | aggregate
 --|name | qualified_expression | allocator | (expression)
 
    function Primary
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Primary");
    if Rt.Current(Current_Code_State).all = Rt.Number
       then
       Rt.Read(Current_Code_State);
       return True;
       elsif Rt.Current(Current_Code_State).all = "null"
       then
       Rt.Read(Current_Code_State);
       return True;
       elsif String_Literal
       or else Aggregate
       or else Expression_A
       or else Qualified_Expression
       or else Allocator
       then
       return True;
       elsif Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          return True;
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Primary;
 --|
 --|              ||
 --|              | Logical_Operator                               |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --logical_operator ::=  and  |  or  |  xor
 
    function Logical_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Logical_Operator");
    if Rt.Current(Current_Code_State).all = "and"
       or else Rt.Current(Current_Code_State).all = "or"
       or else Rt.Current(Current_Code_State).all = "xor"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Logical_Operator;
 --|
 --|              ||
 --|              | Relational_Operator                            |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --relational_operator ::=  =  |  /=  |  <  |  <=  |  >  |  >=
 
    function Relational_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Relational_Operator");
    if Rt.Current(Current_Code_State).all = "="
       or else Rt.Current(Current_Code_State).all = "/="
       or else Rt.Current(Current_Code_State).all = "<"
       or else Rt.Current(Current_Code_State).all = "<="
       or else Rt.Current(Current_Code_State).all = ">"
       or else Rt.Current(Current_Code_State).all = ">="
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Relational_Operator;
 --|
 --|              ||
 --|              | Binary_Adding_Operator                         |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --binary_adding_operator ::=  +  |  -  |  &
 
    function Binary_Adding_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Binary_Adding_Operator");
    if Rt.Current(Current_Code_State).all = "+"
       or else Rt.Current(Current_Code_State).all = "-"
       or else Rt.Current(Current_Code_State).all = "&"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Binary_Adding_Operator;
 --|
 --|              ||
 --|              | Unary_Adding_Operator                          |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --unary_adding_operator ::=  +  |  -
 
    function Unary_Adding_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Unary_Adding_Operator");
    if Rt.Current(Current_Code_State).all = "+"
       or else Rt.Current(Current_Code_State).all = "-"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Unary_Adding_Operator;
 --|
 --|              ||
 --|              | Multiplying_Operator                           |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --multiplying_operator ::=  *  |  /  |  mod  |  rem
 
    function Multiplying_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Multiplying_Operator");
    if Rt.Current(Current_Code_State).all = "*"
       or else Rt.Current(Current_Code_State).all = "/"
       or else Rt.Current(Current_Code_State).all = "mod"
       or else Rt.Current(Current_Code_State).all = "rem"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Multiplying_Operator;
 --|
 --|              ||
 --|              | Highest_Precedence_Operator                    |
 --|              |________________________________________________|
 --|
 
 --4.5:
 --highest_precedence_operator ::=  **  |  abs  |  not
 
    function Highest_Precedence_Operator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Highest_Precedence_Operator");
    if Rt.Current(Current_Code_State).all = "**"
       or else Rt.Current(Current_Code_State).all = "abs"
       or else Rt.Current(Current_Code_State).all = "not"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    Current_Code_State := Code_State_In_Test;
    return False;
    end Highest_Precedence_Operator;
 --|
 --|              ||
 --|              | Type_Conversion                           |
 --|              |___________________________________________|
 --|
 
 --4.6:
 --type_conversion ::=
 --subtype_mark(expression)
 --|subtype_mark(name)
 
    function Type_Conversion
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Type_Conversion");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not (A_Name or else Expression) --name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Type_Conversion;
 --|
 --|              ||
 --|              | Qualified_Expression                      |
 --|              |___________________________________________|
 --|
 
 --4.7:
 --qualified_expression ::=
 --subtype_mark'(expression) | subtype_mark'aggregate
 
    function Qualified_Expression
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Qualified_Expression");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "'"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       Dummy := Expression;
       if Dummy and then Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          return True;
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       return Aggregate;
    end if;
    end Qualified_Expression;
 --|
 --|              ||
 --|              | Allocator                                 |
 --|              |___________________________________________|
 --|
 --4.8:
 
 --allocator ::=
 --new subtype_indication | new qualified_expression
    function Allocator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Allocator");
    if Rt.Current(Current_Code_State).all = "'"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not (Subtype_Indication or else Expression)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Allocator;
 --|
 --|              ||
 --|              | Sequence_Of_Statements                    |
 --|              |___________________________________________|
 --|
 
 --5.1:
 --sequence_of_statements ::= statement { statement }
 
    function Sequence_Of_Statements
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("sequence_of_statements");
    Result := Statement;
    if not Result
       then
       Rt.Trace("sequence_of_statements  return false      ");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Statement;
    end loop;
    if Rt.Current(Current_Code_State).all = "end"
       or else Rt.Current(Current_Code_State).all = "begin"
       or else Rt.Current(Current_Code_State).all = "declare"
       or else Rt.Current(Current_Code_State).all = "elsif"
       or else Rt.Current(Current_Code_State).all = "else"
       or else Rt.Current(Current_Code_State).all = "when"
       or else Rt.Current(Current_Code_State).all = "exception"
       or else Rt.Current(Current_Code_State).all = "or"
       then
       Rt.Trace("sequence_of_statements  return " & Boolean'Image(Result));
       return Result;
       else
       Set_Error_Message(To => "error sequence_of_statements at : " & Rt.Current(Current_Code_State).all);
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("sequence_of_statements  return " & Boolean'Image(Result));
       return False;
    end if;
    end Sequence_Of_Statements;
 --|
 --|              ||
 --|              | Statement                                 |
 --|              |___________________________________________|
 --|
 
 --5.1:
 
 --statement ::=
 --{ label } simple_statement | { label } compound_statement
 
    function Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Statement " & Rt.Current(Current_Code_State).all);
    Dummy := Label;
    Dummy := Simple_Statement or else Compound_Statement;
    Rt.Trace("Statement  return " & Boolean'Image(Dummy) & Rt.Current_Line);
    return Dummy;
    end Statement;
 --|
 --|              ||
 --|              | Simple_Statement                          |
 --|              |___________________________________________|
 --|
 --5.1:
 
 --simple_statement ::= null_statement
 --|assignment_statement|exit_statement
 --|goto_statement|procedure_call_statement
 --|return_statement|entry_call_statement
 --|requeue_statement|delay_statement
 --|abort_statement|raise_statement
 --|code_statement
 
    function Simple_Statement
    return Boolean
    is
    Result             : Boolean            := False;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Simple_Statement" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "null"
       then
       Result := Null_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "exit"
       then
       Result := Exit_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "goto"
       then
       Result := Goto_Statement;--done
       elsif Rt.Current(Current_Code_State).all = "return"
       then
       Result := Return_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "entry"
       then
       Result := Entry_Call_Statement;
       elsif Rt.Current(Current_Code_State).all = "requeue"
       then
       Result := Requeue_Statement;
       elsif Rt.Current(Current_Code_State).all = "delay"
       then
       Result := Delay_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "abort"
       then
       Result := Abort_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "raise"
       then
       Result := Raise_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "if"
       then
       Result := If_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "case"
       then
       Result := Case_Statement;-- done
       --elsif Rt.Current(Current_Code_State).all = "loop"
       --then
       --Result := Loop_Statement;--done
       elsif Rt.Current(Current_Code_State).all = "accept"
       then
       Result := Accept_Statement;-- done
       elsif Rt.Current(Current_Code_State).all = "select"
       then
       Result := Select_Statement;
    end if;
    Result := Result
    or else Loop_Statement
    or else Block_Statement
    or else Assignment_Statement
    or else Procedure_Call_Statement
    or else Code_Statement
    or else Pragma_X;
    Rt.Trace("Simple_Statement return " & Boolean'Image(Result));
 
    return Result;
    end Simple_Statement;
 --|
 --|              ||
 --|              | Compound_Statement                        |
 --|              |___________________________________________|
 --|
 
 --5.1:
 --compound_statement ::=
 --if_statement|case_statement
 --|loop_statement|block_statement
 --|accept_statement|select_statement
 
    function Compound_Statement
    return Boolean
    is
    --Result             : Boolean;
    --Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Compound_Statement " & Rt.Current(Current_Code_State).all);
    return False;
    end Compound_Statement;
 --|
 --|              ||
 --|              | Null_Statement                            |
 --|              |___________________________________________|
 --|
 
 --5.1:
 --null_statement ::= null;
 
    function Null_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Null_Statement");
    if Rt.Current(Current_Code_State).all = "null"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "missing Colon Null_Statement");
       return False;
    end if;
    return True;
    end Null_Statement;
 --|
 --|              ||
 --|              |          Label                            |
 --|              |___________________________________________|
 --|
 
 --5.1:
 --label ::= <<label_statement_identifier>>
 
    function Label
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Label");
    if Rt.Current(Current_Code_State).all = "<<"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ">>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Label;
 --|
 --|              ||
 --|              |            Statement_Identifier                |
 --|              |________________________________________________|
 --|
 --5.1:
 
 --statement_identifier ::= direct_name
    function Statement_Identifier
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Statement_Identifier");
    return Direct_Name;
    end Statement_Identifier;
 --|
 --|              ||
 --|              | Assignment_Statement                      |
 --|              |___________________________________________|
 --|
 --5.2:
 --assignment_statement ::=
 --variable_name := expression;
 
    function Assignment_Statement
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Assignment_Statement " & Rt.Current(Current_Code_State).all);
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("left part of Assignment_Statement return false");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       Result := True;
       else
       Rt.Trace(":= not found in Assignment_Statement return false");
       Result := False;
    end if;
    if Result and then Expression_A
       then
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          Result := True;
          else
          Result := False;
          Rt.Trace("; not found in Assignment_Statement return false");
 
       end if;
       else
       Result := False;
       Rt.Trace("Result and then Name in Assignment_Statement return false");
    end if;
    Rt.Trace("right part Assignment_Statement return " & Boolean'Image(Result));
    if not Result
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Assignment_Statement;
 --|
 --|              ||
 --|              | If_Statement                              |
 --|              |___________________________________________|
 --|
 
 --5.3:
 --if_statement ::=
 --if condition then
 --sequence_of_statements
 --{ elsif condition then
 --sequence_of_statements }
 --[else
 --sequence_of_statements]
 --end if;
 
    function If_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("If_Statement"
             & Rt.Current(Current_Code_State).all
             & Rt.Next(Current_Code_State).all
             & Rt.After(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "if"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "then"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= "elsif";
       Rt.Read(Current_Code_State);
       if not Expression_A
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "then"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not Sequence_Of_Statements
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = "else"
       then
       Rt.Read(Current_Code_State);
       if not Sequence_Of_Statements
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "if"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Colon If_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end If_Statement;
 --|
 --|              ||
 --|              | Condition                                 |
 --|              |___________________________________________|
 --|
 
 --5.3:
 --condition ::= boolean_expression
 
    function Condition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Condition");
    return Expression;
    end Condition;
 --|
 --|              ||
 --|              | Case_Statement                            |
 --|              |___________________________________________|
 --|
 
 --5.4:
 --case_statement ::=
 --case expression is
 --case_statement_alternative
 --{ case_statement_alternative }
 --end case;
 
    function Case_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Case_Statement"
             & Rt.Current(Current_Code_State).all
             & Rt.Next(Current_Code_State).all
             & Rt.After(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all /= "case"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all /= "is"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if not Case_Statement_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Case_Statement_Alternative;
    end loop;
    if Rt.Current(Current_Code_State).all /= "end"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all /= "case"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all /= ";"
       then
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "missing Colon Case_Statement");
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    return True;
    end Case_Statement;
 --|
 --|              ||
 --|              | Case_Statement_Alternative                |
 --|              |___________________________________________|
 --|
 
 --5.4:
 --case_statement_alternative ::=
 --when discrete_choice_list =>
 --sequence_of_statements
 
    function Case_Statement_Alternative
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Case_Statement_Alternative");
    if Rt.Current(Current_Code_State).all /= "when"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if not Discrete_Choice_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all /= "=>"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if not Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Case_Statement_Alternative;
 --|
 --|              ||
 --|              |            Loop_Statement                      |
 --|              |________________________________________________|
 --|
 --5.5:
 
 --loop_statement ::=
 --[loop_statement_identifier:]
 --[iteration_scheme] loop
 --sequence_of_statements
 --end loop [loop_identifier];
    function Loop_Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Loop_Statement");
    Dummy := Rt.Current(Current_Code_State).all = Rt.Identifier
    and then Rt.Next(Current_Code_State).all = ":";
    if Dummy
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
    end if;
    Dummy := Iteration_Scheme;
    if Rt.Current(Current_Code_State).all = "loop"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Loop_Statement missing loop");
       return False;
    end if;
    Dummy := Sequence_Of_Statements;
    if Rt.Current(Current_Code_State).all = "end"
       and then Rt.Next(Current_Code_State).all = "loop"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    Rt.Trace("Loop_Statement   loop   ? "
             & Rt.Current(Current_Code_State).all
             & Rt.Next(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Colon Loop_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Loop_Statement return true");
    return True;
    end Loop_Statement;
 --|
 --|              ||
 --|              |         Iteration_Scheme                       |
 --|              |________________________________________________|
 --|
 --5.5:
 
 --iteration_scheme ::= while condition
 --|for loop_parameter_specification
    function Iteration_Scheme
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Iteration_Scheme" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "while"
       then
       Rt.Read(Current_Code_State);
       if not Condition
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       elsif Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       if not Loop_Parameter_Specification
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Rt.Trace("Iteration_Scheme true " & Rt.Current(Current_Code_State).all);
    return True;
    end Iteration_Scheme;
 --|
 --|              ||
 --|              |      loop_parameter_specification              |
 --|              |________________________________________________|
 --|
 --5.5:
 
 --loop_parameter_specification ::=
 --defining_identifier in [reverse] discrete_subtype_definition
    function Loop_Parameter_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Loop_Parameter_Specification " & Rt.Current(Current_Code_State).all);
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "in"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "reverse"
       then
       Rt.Read(Current_Code_State);
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Loop_Parameter_Specification;
 --|
 --|              ||
 --|              |     Block_Statement                            |
 --|              |________________________________________________|
 --|
 --5.6:
 
 --block_statement ::=
 --[block_statement_identifier:]
 --[declare
 --declarative_part]
 --              begin
 --handled_sequence_of_statements
 --end [block_identifier];
    function Block_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Block_Statement");
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       and then Rt.Next(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "declare"
       then
       Rt.Read(Current_Code_State);
       if not Declarative_Part
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = "begin"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Handled_Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Colon Block_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Block_Statement;
 --|
 --|              ||
 --|              | Exit_Statement                                 |
 --|              |________________________________________________|
 --|
 
 --5.7:
 --exit_statement ::=
 --exit [loop_name] [when condition];
    function Exit_Statement
    return Boolean
    is
    Result             : Integer            := 0;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Exit_Statement");
    if Rt.Current(Current_Code_State).all = "exit"
       then
       Result := 1;
       Rt.Read(Current_Code_State);
    end if;
    if Result = 1 and then A_Name
       then
       null;
    end if;
    if Result = 1 and then Rt.Current(Current_Code_State).all = "when"
       then
       Result := 2;
       Rt.Read(Current_Code_State);
    end if;
    if Result = 2 and then Expression_A --Condition
       then
       Result := 3;
    end if;
    if not (Result = 1 or else Result = 3)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Colon Exit_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Exit_Statement;
 --|
 --|              ||
 --|              |       Goto_Statement                           |
 --|              |________________________________________________|
 --|
 
 --5.8:
 --goto_statement ::= goto label_name;
    function Goto_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Goto_Statement");
    if Rt.Current(Current_Code_State).all = "goto"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Goto_Statement;
 --|
 --|              ||
 --|              | Subprogram_Declaration                         |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --subprogram_declaration ::= subprogram_specification;
    function Subprogram_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Declaration " & Rt.Current(Current_Code_State).all);
    if not Subprogram_Specification
       then
       Rt.Trace("Subprogram_Declaration returns false A");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Subprogram_Declaration returns false B no ;");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Subprogram_Declaration returns true");
    return True;
    end Subprogram_Declaration;
 --|
 --|              ||
 --|              | abstract_subprogram_declaration                |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --abstract_subprogram_declaration ::= subprogram_specification is abstract;
    function Abstract_Subprogram_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Abstract_Subprogram_Declaration " & Rt.Current(Current_Code_State).all);
    if not Subprogram_Specification
       then
       Current_Code_State := Code_State_In_Test;--ww
       return False;
    end if;
    Rt.Trace("Abstract_Subprogram_Declaration is ?" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Abstract_Subprogram_Declaration abstract ?" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Abstract_Subprogram_Declaration ; ?" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Abstract_Subprogram_Declaration return true");
    return True;
    end Abstract_Subprogram_Declaration;
 --|
 --|              ||
 --|              | subprogram_specification                       |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --subprogram_specification ::=
 --procedure defining_program_unit_name  parameter_profile
 --|function defining_designator  parameter_and_result_profile
 
    function Subprogram_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Specification");
    Rt.Trace(Rt.Print(Current_Code_State));
    if Rt.Current(Current_Code_State).all = "procedure"
       then
       Rt.Read(Current_Code_State);
       if not Defining_Program_Unit_Name
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Subprogram_Specification returns false A");
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
       if not Parameter_Profile
          then
          Rt.Trace("Subprogram_Specification returns false B");
          Rt.Trace(Rt.Print(Current_Code_State));
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Rt.Trace("Subprogram_Specification  Procedure ok");
       elsif Rt.Current(Current_Code_State).all = "function"
       then
       Rt.Read(Current_Code_State);
       if not Defining_Designator
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Subprogram_Specification returns false C");
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
       if not Parameter_And_Result_Profile
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Subprogram_Specification returns false D");
          Rt.Trace(Rt.Print(Current_Code_State));
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Specification returns false E");
       Rt.Trace(Rt.Print(Current_Code_State));
       return False;
    end if;
    Rt.Trace("Subprogram_Specification returns TRUE for Function");
    Rt.Trace(Rt.Print(Current_Code_State));
    return True;
    end Subprogram_Specification;
 --|
 --|              ||
 --|              |               Designator                       |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --designator ::= [parent_unit_name . ] identifier | operator_symbol
    function Designator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Designator");
    if not (A_Name or else Operator_Symbol)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Designator;
 --|
 --|              ||
 --|              |          defining_designator                   |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --defining_designator ::= defining_program_unit_name | defining_operator_symbol
    function Defining_Designator
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Defining_Designator");
    return Defining_Program_Unit_Name or else Defining_Operator_Symbol;
    end Defining_Designator;
 --|
 --|              ||
 --|              | Defining_Program_Unit_Name                     |
 --|              |________________________________________________|
 --|
 
 --6.1:
 --defining_program_unit_name ::= [parent_unit_name . ] defining_identifier
 
    function Defining_Program_Unit_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Defining_Program_Unit_Name");
    if not A_Name
       then
       return False;
    end if;
    return True;
    end Defining_Program_Unit_Name;
 --|
 --|              ||
 --|              | Operator_Symbol                                |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --operator_symbol ::= string_literal
    function Operator_Symbol
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Operator_Symbol");
    return String_Literal;
    end Operator_Symbol;
 --|
 --|              ||
 --|              |         Defining_Operator_Symbol               |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --defining_operator_symbol ::= operator_symbol
    function Defining_Operator_Symbol
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("defining_operator_symbol");
    return Operator_Symbol;
    end Defining_Operator_Symbol;
 --|
 --|              ||
 --|              | Parameter_Profile                              |
 --|              |________________________________________________|
 --|
 
 --6.1:
 --parameter_profile ::= [formal_part]
    function Parameter_Profile
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Parameter_Profile");
    Dummy := Formal_Part;
    Rt.Trace("Parameter_Profile  Dummy " & Boolean'Image(Dummy));
    return True;
    end Parameter_Profile;
 --|
 --|              ||
 --|              |         Parameter_And_Result_Profile           |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --parameter_and_result_profile ::= [formal_part] return subtype_mark
    function Parameter_And_Result_Profile
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Parameter_And_Result_Profile " & Rt.Current(Current_Code_State).all);
    Dummy := Formal_Part;
    Rt.Trace("Parameter_And_Result_Profile return ? " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "return"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Parameter_And_Result_Profile return False A");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Rt.Trace("Parameter_And_Result_Profile return False B");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Parameter_And_Result_Profile return TRUE");
    return True;
    end Parameter_And_Result_Profile;
 --|
 --|              ||
 --|              | Formal_Part                                    |
 --|              |________________________________________________|
 --|
 
 --6.1:
 --formal_part ::=
 --(parameter_specification { ; parameter_specification })
 
    function Formal_Part
    return Boolean
    is
    --Result : Boolean;
    --Dummy  : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Part" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Formal_Part returns false a" & Rt.Current(Current_Code_State).all);
       return False;
    end if;
    if not Parameter_Specification
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Formal_Part returns false b" & Rt.Current(Current_Code_State).all);
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Parameter_Specification
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Formal_Part returns false c" & Rt.Current(Current_Code_State).all);
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Formal_Part returns false d" & Rt.Current(Current_Code_State).all);
       return False;
    end if;
    Rt.Trace("Formal_Part returns true " & Rt.Current(Current_Code_State).all);
    return True;
    end Formal_Part;
 --|
 --|              ||
 --|              |           Parameter_Specification              |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --parameter_specification ::=
 --defining_identifier_list : mode  subtype_mark [:= default_expression]
 --|defining_identifier_list : access_definition [:= default_expression]
 
    function Parameter_Specification
    return Boolean
    is
    Dummy_Code_State   : Rt.Code_State_Type := Current_Code_State;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Test               : Boolean            := True;
    begin
    Rt.Trace("Parameter_Specification 1 " & Rt.Current(Current_Code_State).all);
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Parameter_Specification 2 " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Parameter_Specification 3 " & Rt.Current(Current_Code_State).all);
    Dummy_Code_State := Current_Code_State;
    Test             := False;
    if Mode_X
       then
       Test := True;
       Rt.Trace("Parameter_Specification 4 " & Rt.Current(Current_Code_State).all);
       if not A_Name
          then
          Current_Code_State := Dummy_Code_State;
          Test               := False;
       end if;
    end if;
    if not (Test or else Access_Definition) --
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Parameter_Specification 5 " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       if not Expression_B
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Rt.Trace("Parameter_Specification  RETURNS TRUE 6" & Rt.Current(Current_Code_State).all);
    return True;
    end Parameter_Specification;
 --|
 --|              ||
 --|              |             Mode_X                             |
 --|              |________________________________________________|
 --|
 --6.1:
 
 --mode ::= [in] | in out | out
    function Mode_X
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
 
    Rt.Trace("Mode_X");
    if Rt.Current(Current_Code_State).all = "in" and then Rt.Next(Current_Code_State).all = "out"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
       return True;
       elsif Rt.Current(Current_Code_State).all = "out"
       then
       Rt.Read(Current_Code_State);
       return True;
       elsif Rt.Current(Current_Code_State).all = "in"
       then
       Rt.Read(Current_Code_State);
       return True;
    end if;
    return True;
    end Mode_X;
 --|
 --|              ||
 --|              | Subprogram_Body                                |
 --|              |________________________________________________|
 --|
 
 --6.3:
 --subprogram_body ::=
 --subprogram_specification is
 --declarative_part
 --              begin
 --handled_sequence_of_statements
 --end [designator];
 
    function Subprogram_Body
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Body");
    if not Subprogram_Specification
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false A");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Subprogram_Body missing is");
       Rt.Trace("Subprogram_Body returns false B");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Declarative_Part
       then
       Set_Error_Message(To => " Declarative_Part ");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false C");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "begin"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Subprogram_Body missing begin");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false D");
       return False;
    end if;
    if not Handled_Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false E");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false F");
       return False;
    end if;
    Dummy := A_Name;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "missing Semicolon Subprogram_Body");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Subprogram_Body returns false H");
       return False;
    end if;
    Rt.Trace("Subprogram_Body returns TRUE ");
    return True;
    end Subprogram_Body;
 --|
 --|              ||
 --|              |       Procedure_Call_Statement                 |
 --|              |________________________________________________|
 --|
 --6.4:
 
 --procedure_call_statement ::=
 --procedure_name;
 --|procedure_prefix actual_parameter_part;
    function Procedure_Call_Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Procedure_Call_Statement " & Rt.Current(Current_Code_State).all);
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Actual_Parameter_Part;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Procedure_Call_Statement;
 --|
 --|              ||
 --|              |           Function_Call                        |
 --|              |________________________________________________|
 --|
 --6.4:
 
 --function_call ::=
 --function_name
 --|function_prefix actual_parameter_part
    function Function_Call
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Function_Call " & Rt.Current(Current_Code_State).all);
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Actual_Parameter_Part;
    Rt.Trace("Function_Call returns true");
    return True;
    end Function_Call;
 --|
 --|              ||
 --|              |     Actual_Parameter_Part                      |
 --|              |________________________________________________|
 --|
 --6.4:
 
 --actual_parameter_part ::=
 --(parameter_association { , parameter_association })
    function Actual_Parameter_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Actual_Parameter_Part");
 
    if Rt.Current(Current_Code_State).all /= "("
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    if not Parameter_Association
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = ","
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Parameter_Association
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all /= ")"
       then
       Current_Code_State := Code_State_In_Test;
       return False;
       else
       Rt.Read(Current_Code_State);
    end if;
    return True;
    end Actual_Parameter_Part;
 --|
 --|              ||
 --|              |       Parameter_Association                    |
 --|              |________________________________________________|
 --|
 --6.4:
 
 --parameter_association ::=
 --[formal_parameter_selector_name =>] explicit_actual_parameter
    function Parameter_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Parameter_Association");
    if Rt.Current(Current_Code_State).all = Rt.Identifier and then Rt.Next(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
    end if;
    if not Explicit_Actual_Parameter
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Parameter_Association;
 --|
 --|              ||
 --|              |        Explicit_Actual_Parameter               |
 --|              |________________________________________________|
 --|
 --6.4:
 
 --explicit_actual_parameter ::= expression | variable_name
    function Explicit_Actual_Parameter
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Explicit_Actual_Parameter");
    return Expression_B or else A_Name;
    end Explicit_Actual_Parameter;
 --|
 --|              ||
 --|              | Return_Statement                               |
 --|              |________________________________________________|
 --|
 
 --6.5:
 --return_statement ::= return [expression];
 
    function Return_Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Return_Statement");
    if Rt.Current(Current_Code_State).all = "return"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Expression_A;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Return_Statement;
 --|
 --|              ||
 --|              |          Package_Declaration                   |
 --|              |________________________________________________|
 --|
 --7.1:
 
 --package_declaration ::= package_specification;
    function Package_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Package_Declaration");
    if not Package_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Package_Declaration;
 --|
 --|              ||
 --|              |       Package_Specification                    |
 --|              |________________________________________________|
 --|
 --7.1:
 
 --package_specification ::=package defining_program_unit_name is { basic_declarative_item }
 --[private{ basic_declarative_item }] end [[parent_unit_name.]identifier]
    function Package_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Package_Specification");
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Defining_Program_Unit_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not Basic_Declarative_Item;
    end loop;
    Rt.Trace("Package_Specification after 1st Basic_Declarative_Item");
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       loop
          exit when not Basic_Declarative_Item;
       end loop;
    end if;
    Rt.Trace("Package_Specification after 2nd (option) Basic_Declarative_Item end ?"
             & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Package_Specification;
 --|
 --|              ||
 --|              |         Package_Body                           |
 --|              |________________________________________________|
 --|
 --7.2:
 
 --package_body ::=
 --package body defining_program_unit_name is
 --declarative_part
 --[              begin
 --handled_sequence_of_statements]
 --end [[parent_unit_name.]identifier];
    function Package_Body
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Package_Body");
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Defining_Program_Unit_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Declarative_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "begin"
       then
       Rt.Read(Current_Code_State);
       if not Handled_Sequence_Of_Statements
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Rt.Trace("Package_Body  end ?" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Package_Body  a_name ?" & Rt.Current(Current_Code_State).all);
    Dummy := A_Name;
    Rt.Trace("Package_Body  ; ?" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Package_Body");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Package_Body;
 --|
 --|              ||
 --|              |      Private_Type_Declaration                  |
 --|              |________________________________________________|
 --|
 --7.3:
 
 --private_type_declaration ::=
 --type defining_identifier [discriminant_part] is [[abstract] tagged] [limited] private;
    function Private_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Private_Type_Declaration" & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Private_Type_Declaration returns  A");
       return False;
    end if;
    Dummy := Discriminant_Part;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Private_Type_Declaration returns b");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "tagged"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "limited"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Private_Type_Declaration returns c");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Private_Type_Declaration");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Private_Type_Declaration returns d");
       return False;
    end if;
    Rt.Trace("Private_Type_Declaration returns true");
    return True;
    end Private_Type_Declaration;
 --|
 --|              ||
 --|              |        Private_Extension_Declaration           |
 --|              |________________________________________________|
 --|
 --7.3:
 
 --private_extension_declaration ::=
 --type defining_identifier [discriminant_part] is
 --[abstract] new ancestor_subtype_indication with private;
    function Private_Extension_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Private_Extension_Declaration");
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Discriminant_Part;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "new"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Subtype_Indication
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Private_Extension_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Private_Extension_Declaration;
 --|
 --|              ||
 --|              |  Use_Clause            |
 --|              |________________________|
 --|
 
 --8.4:
 --use_clause ::= use_package_clause | use_type_clause
 
    function Use_Clause
    return Boolean
    is
    begin
    Rt.Trace("Use_Clause");
    return Use_Package_Clause or else Use_Type_Clause;
    end Use_Clause;
 --|
 --|              ||
 --|              |  Use_Package_Clause    |
 --|              |________________________|
 --|
 
 --8.4:
 --use_package_clause ::= use package_name { , package_name };
 
    function Use_Package_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Use_Package_Clause : " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not (Rt.Current(Current_Code_State).all = ",");
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Use_Package_Clause");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Use_Package_Clause;
 --|
 --|              ||
 --|              |  Use_Type_Clause       |
 --|              |________________________|
 --|
 
 --8.4:
 --use_type_clause ::= use type subtype_mark { , subtype_mark };
 
    function Use_Type_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Use_Type_Clause : " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = "type"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not (Rt.Current(Current_Code_State).all = ",");
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Use_Type_Clause");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Use_Type_Clause;
 --|
 --|              ||
 --|              |             Renaming_Declaration               |
 --|              |________________________________________________|
 --|
 --8.5:
 
 --renaming_declaration ::=
 --object_renaming_declaration
 --|exception_renaming_declaration
 --|package_renaming_declaration
 --|subprogram_renaming_declaration
 --|generic_renaming_declaration
    function Renaming_Declaration
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Renaming_Declaration");
    Result := Object_Renaming_Declaration
    or else Exception_Renaming_Declaration
    or else Package_Renaming_Declaration
    or else Subprogram_Renaming_Declaration
    or else Generic_Renaming_Declaration;
    Rt.Trace("Renaming_Declaration returns " & Boolean'Image(Result));
    return Result;
    end Renaming_Declaration;
 --|
 --|              ||
 --|              |         Object_Renaming_Declaration            |
 --|              |________________________________________________|
 --|
 --8.5.1:
 
 --object_renaming_declaration ::= defining_identifier : subtype_mark renames object_name;
    function Object_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Object_Renaming_Declaration " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "renames"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A --||
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Object_Renaming_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Object_Renaming_Declaration;
 --|
 --|              ||
 --|              |        Exception_Renaming_Declaration          |
 --|              |________________________________________________|
 --|
 --8.5.2:
 
 --exception_renaming_declaration ::= defining_identifier : exception renames exception_name;
    function Exception_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Exception_Renaming_Declaration");
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "exception"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "renames"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Exception_Renaming_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Exception_Renaming_Declaration;
 --|
 --|              ||
 --|              |       Package_Renaming_Declaration             |
 --|              |________________________________________________|
 --|
 --8.5.3:
 
 --package_renaming_declaration ::= package defining_program_unit_name renames package_name;
    function Package_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Package_Renaming_Declaration");
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Defining_Program_Unit_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "renames"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Package_Renaming_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Package_Renaming_Declaration;
 --|
 --|              ||
 --|              |        Subprogram_Renaming_Declaration         |
 --|              |________________________________________________|
 --|
 --8.5.4
 
 --subprogram_renaming_declaration ::= subprogram_specification renames callable_entity_name;
    function Subprogram_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Renaming_Declaration " & Rt.Current(Current_Code_State).all);
    if not Subprogram_Specification
       then
       Rt.Trace("Subprogram_Renaming_Declaration returns False A");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "renames"
       then
       Rt.Read(Current_Code_State);
       else
       Rt.Trace("Subprogram_Renaming_Declaration returns False B");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Rt.Trace("Subprogram_Renaming_Declaration returns False C");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Subprogram_Renaming_Declaration");
       Rt.Trace("Subprogram_Renaming_Declaration returns False D");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Subprogram_Renaming_Declaration TRUE ");
    return True;
    end Subprogram_Renaming_Declaration;
 --|
 --|              ||
 --|              |      Generic_Renaming_Declaration              |
 --|              |________________________________________________|
 --|
 --8.5.5:
 
 --generic_renaming_declaration ::=
 --generic package defining_program_unit_name renames generic_package_name;
 --|generic procedure defining_program_unit_name renames generic_procedure_name;
 --|generic function defining_program_unit_name renames generic_function_name;
    function Generic_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Renaming_Declaration");
    if Rt.Current(Current_Code_State).all = "generic"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "package"
       or else Rt.Current(Current_Code_State).all = "procedure"
       or else Rt.Current(Current_Code_State).all = "function"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Defining_Program_Unit_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "renames"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Generic_Renaming_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Generic_Renaming_Declaration;
 --|
 --|              ||
 --|              |    Task_Type_Declaration                       |
 --|              |________________________________________________|
 --|
 --9.1:
 
 --task_type_declaration ::=
 --task type defining_identifier [known_discriminant_part] [is task_definition];
    function Task_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Task_Type_Declaration");
    if Rt.Current(Current_Code_State).all = "task"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Known_Discriminant_Part;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       if not Task_Definition
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon  Task_Type_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Task_Type_Declaration;
 --|
 --|              ||
 --|              |           Single_Task_Declaration              |
 --|              |________________________________________________|
 --|
 --9.1:
 
 --single_task_declaration ::=
 --task defining_identifier [is task_definition];
    function Single_Task_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Single_Task_Declaration");
    if Rt.Current(Current_Code_State).all = "task"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       if not Task_Definition
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Single_Task_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Single_Task_Declaration;
 --|
 --|              ||
 --|              |           Task_Definition                      |
 --|              |________________________________________________|
 --|
 --9.1:
 
 --task_definition ::=
 --{ task_item }
 --[ private
 --{ task_item }]
 --end [task_identifier]
    function Task_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Task_Definition");
    loop
       exit when not Task_Item;
    end loop;
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       loop
          exit when not Task_Item;
       end loop;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    return True;
    end Task_Definition;
 --|
 --|              ||
 --|              |             Task_Item                          |
 --|              |________________________________________________|
 --|
 --9.1:
 
 --task_item ::= entry_declaration | representation_clause
    function Task_Item
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Task_Item");
    return Entry_Declaration or else Representation_Clause;
    end Task_Item;
 --|
 --|              ||
 --|              |         Task_Body                              |
 --|              |________________________________________________|
 --|
 --9.1:
 
 --task_body ::=
 --task body defining_identifier is
 --declarative_part
 --              begin
 --handled_sequence_of_statements
 --end [task_identifier];
    function Task_Body
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Task_Body");
    if Rt.Current(Current_Code_State).all = "task"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Declarative_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "begin"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Handled_Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := A_Name;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Task_Body");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Task_Body;
 --|
 --|              ||
 --|              |     Protected_Type_Declaration                 |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_type_declaration ::=
 --protected type defining_identifier [known_discriminant_part] is protected_definition;
    function Protected_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Type_Declaration");
 
    if Rt.Current(Current_Code_State).all = "protected"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Known_Discriminant_Part;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Protected_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Protected_Type_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Protected_Type_Declaration;
 --|
 --|              ||
 --|              |       Single_Protected_Declaration             |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --single_protected_declaration ::=
 --protected defining_identifier is protected_definition;
    function Single_Protected_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Single_Protected_Declaration");
 
    if Rt.Current(Current_Code_State).all = "protected"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Protected_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Single_Protected_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Single_Protected_Declaration;
 --|
 --|              ||
 --|              |        Protected_Definition                    |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_definition ::=
 --{ protected_operation_declaration }
 --[ private
 --{ protected_element_declaration } ]
 --end [protected_identifier]
    function Protected_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Definition");
    loop
       exit when not Protected_Operation_Declaration;
    end loop;
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       loop
          exit when not Protected_Element_Declaration;
       end loop;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    return True;
    end Protected_Definition;
 --|
 --|              ||
 --|              |         Protected_Operation_Declaration        |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_operation_declaration ::= subprogram_declaration
 --|entry_declaration
 --|representation_clause
    function Protected_Operation_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Operation_Declaration");
    return Subprogram_Declaration or else Entry_Declaration or else Representation_Clause;
    end Protected_Operation_Declaration;
 --|
 --|              ||
 --|              |        Protected_Element_Declaration           |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_element_declaration ::= protected_operation_declaration
 --|component_declaration
    function Protected_Element_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Element_Declaration");
    return Protected_Operation_Declaration or else Component_Declaration;
    end Protected_Element_Declaration;
 --|
 --|              ||
 --|              |        Protected_Body                          |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_body ::=
 --protected body defining_identifier is
 --{ protected_operation_item }
 --end [protected_identifier];
    function Protected_Body
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Body");
    if Rt.Current(Current_Code_State).all = "protected"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False A");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False B");
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False C");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False d");
       return False;
    end if;
    loop
       exit when not Protected_Operation_Item;
    end loop;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False e");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Protected_Body");
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Protected_Body return False f");
       return False;
    end if;
    Rt.Trace("Protected_Body return true");
    return True;
 
    end Protected_Body;
 --|
 --|              ||
 --|              |         Protected_Operation_Item               |
 --|              |________________________________________________|
 --|
 --9.4:
 
 --protected_operation_item ::= subprogram_declaration
 --|subprogram_body
 --|entry_body
 --|representation_clause
    function Protected_Operation_Item
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("Protected_Operation_Item");
    Result := Subprogram_Declaration or else Subprogram_Body or else Entry_Body or else Representation_Clause;
    Rt.Trace("Protected_Operation_Item " & Boolean'Image(Result));
    return Result;
    end Protected_Operation_Item;
 --|
 --|              ||
 --|              |       Entry_Declaration                        |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_declaration ::=
 --entry defining_identifier [(discrete_subtype_definition)] parameter_profile;
    function Entry_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Temp_Code_State    : Rt.Code_State_Type;
    begin
    Rt.Trace("Entry_Declaration");
    if Rt.Current(Current_Code_State).all = "entry"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Temp_Code_State := Current_Code_State;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Expression_A
          then
          Current_Code_State := Temp_Code_State;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Temp_Code_State;
       end if;
    end if;
    if not Parameter_Profile
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Entry_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Entry_Declaration;
 --|
 --|              ||
 --|              |          Accept_Statement                      |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --accept_statement ::=
 --accept entry_direct_name [(entry_index)] parameter_profile [do
 --handled_sequence_of_statements
 --end [entry_identifier]];
    function Accept_Statement
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Dummy_Code_State   : Rt.Code_State_Type;
    begin
    Rt.Trace("Accept_Statement");
    if Rt.Current(Current_Code_State).all = "accept"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Dummy_Code_State := Current_Code_State;
       Rt.Read(Current_Code_State);
       Result := not Entry_Index;
       if Result and then Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Result := False;
       end if;
       if not Result
          then
          Current_Code_State := Dummy_Code_State;
       end if;
    end if;
    if not Parameter_Profile
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "do"
       then
       Dummy_Code_State := Current_Code_State;
       Rt.Read(Current_Code_State);
       Result := Handled_Sequence_Of_Statements;
       if Result and then Rt.Current(Current_Code_State).all = "end"
          then
          Rt.Read(Current_Code_State);
          else
          Result := False;
       end if;
       if Rt.Current(Current_Code_State).all = Rt.Identifier
          then
          Rt.Read(Current_Code_State);
       end if;
       if not Result
          then
          Current_Code_State := Dummy_Code_State;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Accept_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Accept_Statement;
 --|
 --|              ||
 --|              |                Entry_Index                     |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_index ::= expression
    function Entry_Index
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Index");
    return Expression;
    end Entry_Index;
 --|
 --|              ||
 --|              |            Entry_Body                          |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_body ::=
 --entry defining_identifier  entry_body_formal_part  entry_barrier is
 --declarative_part
 --             begin
 --handled_sequence_of_statements
 --end [entry_identifier];
    function Entry_Body
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Body");
    if Rt.Current(Current_Code_State).all = "entry"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body return 0");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body A");
       return False;
    end if;
    if not Entry_Body_Formal_Part
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body B");
       return False;
    end if;
    if not Entry_Barrier
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body C");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Declarative_Part
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body D");
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "begin"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Handled_Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Entry_Body");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Entry_Body;
 --|
 --|              ||
 --|              |         Entry_Body_Formal_Part                 |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_body_formal_part ::= [(entry_index_specification)] parameter_profile
    function Entry_Body_Formal_Part
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Body_Formal_Part");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if not Entry_Index_Specification
          then
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Entry_Body_Formal_Part A");
          Dummy := False;
       end if;
       if Dummy and Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Rt.Trace("Entry_Body_Formal_Part B");
       end if;
    end if;
    if not Parameter_Profile
       then
       Current_Code_State := Code_State_In_Test;
       Rt.Trace("Entry_Body_Formal_Part C");
       return False;
    end if;
    Rt.Trace("Entry_Body_Formal_Part return true");
    return True;
    end Entry_Body_Formal_Part;
 --|
 --|              ||
 --|              |             Entry_Barrier                      |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_barrier ::= when condition
    function Entry_Barrier
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Barrier");
    if Rt.Current(Current_Code_State).all = "when"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Condition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Entry_Barrier;
 --|
 --|              ||
 --|              |         Entry_Index_Specification              |
 --|              |________________________________________________|
 --|
 --9.5.2:
 
 --entry_index_specification ::= for defining_identifier in discrete_subtype_definition
    function Entry_Index_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Index_Specification");
    if Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Condition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "in"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Discrete_Subtype_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Entry_Index_Specification;
 --|
 --|              ||
 --|              |          Entry_Call_Statement                  |
 --|              |________________________________________________|
 --|
 --9.5.3:
 
 --entry_call_statement ::= entry_name [actual_parameter_part];
    function Entry_Call_Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Call_Statement");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Actual_Parameter_Part;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Entry_Call_Statement;
 --|
 --|              ||
 --|              |            Requeue_Statement                   |
 --|              |________________________________________________|
 --|
 --9.5.4:
 
 --requeue_statement ::= requeue entry_name [with abort];
    function Requeue_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Requeue_Statement");
    if Rt.Current(Current_Code_State).all = "requeue"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
 
       if Rt.Current(Current_Code_State).all = "abort"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Requeue_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Requeue_Statement;
 --|
 --|              ||
 --|              |  Delay_Statement       |
 --|              |________________________|
 --|
 --9.6:
 --delay_statement ::= delay_until_statement | delay_relative_statement
    function Delay_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Delay_Statement");
    return Delay_Until_Statement or else Delay_Relative_Statement;
    end Delay_Statement;
 --|
 --|              ||
 --|              | Delay_Until_Statement  |
 --|              |________________________|
 --|
 
 --9.6:
 --delay_until_statement ::= delay until delay_expression;
    function Delay_Until_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Delay_Until_Statement");
    if Rt.Current(Current_Code_State).all = "delay" and then Rt.Next(Current_Code_State).all = "until"
       then
       Rt.Read(Current_Code_State);
       Rt.Read(Current_Code_State);
       else
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Delay_Until_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Delay_Until_Statement;
 --|
 --|              ||
 --|              |Delay_Relative_Statement|
 --|              |________________________|
 --|
 
 --9.6:
 --delay_relative_statement ::= delay delay_expression;
 
    function Delay_Relative_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Delay_Relative_Statement");
    if Rt.Current(Current_Code_State).all = "delay"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Delay_Relative_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Delay_Relative_Statement;
 --|
 --|              ||
 --|              |              Select_Statement                  |
 --|              |________________________________________________|
 --|
 --9.7:
 
 --select_statement ::=
 --selective_accept
 --|timed_entry_call
 --|conditional_entry_call
 --|asynchronous_select
    function Select_Statement
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Select_Statement");
    Result := Selective_Accept or else Timed_Entry_Call or else Conditional_Entry_Call or else Asynchronous_Select;
    Rt.Trace("Select_Statement resturns " & Boolean'Image(Result));
    return Result;
    end Select_Statement;
 --|
 --|              ||
 --|              |          Selective_Accept                      |
 --|              |________________________________________________|
 --|
 --9.7.1:
 
 --selective_accept ::=
 --select
 --[guard]
 --select_alternative
 --{ or
 --[guard]
 --select_alternative }
 --[ else
 --sequence_of_statements ]
 --end select;
    function Selective_Accept
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Selective_Accept");
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Guard;
    if not Select_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = "or"
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       Dummy := Guard;
       if not Select_Alternative
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = "else"
       then
       Rt.Read(Current_Code_State);
       if not Sequence_Of_Statements
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Rt.Trace("Selective_Accept end ? " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Selective_Accept select ? " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Rt.Trace("Selective_Accept ; ? " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Selective_Accept");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Selective_Accept;
 --|
 --|              ||
 --|              |           Guard                                |
 --|              |________________________________________________|
 --|
 --9.7.1:
 
 --guard ::= when condition =>
    function Guard
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Guard");
    if Rt.Current(Current_Code_State).all = "when"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Condition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Guard;
 --|
 --|              ||
 --|              |             Select_Alternative                 |
 --|              |________________________________________________|
 --|
 --9.7.1:
 
 --select_alternative ::=
 --accept_alternative
 --|delay_alternative
 --|terminate_alternative
    function Select_Alternative
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result0            : Boolean;
    Result1            : Boolean;
    Result2            : Boolean;
    begin
    Rt.Trace("Select_Alternative");
    Result0 := Accept_Alternative;
    Result1 := Delay_Alternative;
    Result2 := Terminate_Alternative;
    Rt.Trace("Select_Alternative" & Boolean'Image(Result0) & Boolean'Image(Result1) & Boolean'Image(Result2));
    return Result0 or else Result1 or else Result2;
    end Select_Alternative;
 --|
 --|              ||
 --|              |          Accept_Alternative                    |
 --|              |________________________________________________|
 --|
 --9.7.1:
 
 --accept_alternative ::=
 --accept_statement [sequence_of_statements]
    function Accept_Alternative
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Accept_Alternative");
    if not Accept_Statement
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Sequence_Of_Statements;
    return True;
    end Accept_Alternative;
 --|
 --|              ||
 --|              |            Delay_Alternative                   |
 --|              |________________________________________________|
 --|
 --9.7.1:
 --delay_alternative ::=
 --delay_statement [sequence_of_statements]
    function Delay_Alternative
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Dummy              : Boolean;
    begin
    Rt.Trace("Delay_Alternative");
    if not Delay_Statement
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Sequence_Of_Statements;
    return True;
    end Delay_Alternative;
 --|
 --|              ||
 --|              |            Terminate_Alternative               |
 --|              |________________________________________________|
 --|
 --9.7.1:
 
 --terminate_alternative ::= terminate;
    function Terminate_Alternative
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Terminate_Alternative");
    if Rt.Current(Current_Code_State).all = "terminate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Terminate_Alternative");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Terminate_Alternative;
 --|
 --|              ||
 --|              |          Timed_Entry_Call                      |
 --|              |________________________________________________|
 --|
 --9.7.2:
 
 --timed_entry_call ::=
 --select
 --entry_call_alternative
 --or
 --delay_alternative
 --end select;
    function Timed_Entry_Call
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Timed_Entry_Call");
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Entry_Call_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "or"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Delay_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Timed_Entry_Call");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Timed_Entry_Call;
 --|
 --|              ||
 --|              |          Entry_Call_Alternative                |
 --|              |________________________________________________|
 --|
 --9.7.2:
 
 --entry_call_alternative ::=
 --entry_call_statement [sequence_of_statements]
    function Entry_Call_Alternative
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Entry_Call_Alternative");
    if not Entry_Call_Statement
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Sequence_Of_Statements;
    return True;
    end Entry_Call_Alternative;
 --|
 --|              ||
 --|              |          Conditional_Entry_Call                |
 --|              |________________________________________________|
 --|
 --9.7.3:
 
 --conditional_entry_call ::=
 --select
 --entry_call_alternative
 --else
 --sequence_of_statements
 --end select;
    function Conditional_Entry_Call
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Conditional_Entry_Call");
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Entry_Call_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       if Rt.Current(Current_Code_State).all = "else"
          then
          Rt.Read(Current_Code_State);
          else
          exit;
       end if;
       if not Sequence_Of_Statements
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Conditional_Entry_Call");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Conditional_Entry_Call;
 --|
 --|              ||
 --|              |           Asynchronous_Select                  |
 --|              |________________________________________________|
 --|
 --9.7.4:
 
 --asynchronous_select ::=
 --select
 --triggering_alternative
 --then abort
 --abortable_part
 --end select;
    function Asynchronous_Select
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Asynchronous_Select");
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Triggering_Alternative
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "then"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "abort"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Abortable_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "select"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Asynchronous_Select");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Asynchronous_Select;
 --|
 --|              ||
 --|              |          Triggering_Alternative                |
 --|              |________________________________________________|
 --|
 --9.7.4:
 
 --triggering_alternative ::= triggering_statement [sequence_of_statements]
    function Triggering_Alternative
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Triggering_Alternative");
 
    if not Triggering_Statement
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Sequence_Of_Statements;
    return True;
    end Triggering_Alternative;
 --|
 --|              ||
 --|              |        Triggering_Statement                    |
 --|              |________________________________________________|
 --|
 --9.7.4:
 
 --triggering_statement ::= entry_call_statement | delay_statement
    function Triggering_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Triggering_Statement");
    return Entry_Call_Statement or else Delay_Statement;
    end Triggering_Statement;
 --|
 --|              ||
 --|              |            Abortable_Part                      |
 --|              |________________________________________________|
 --|
 --9.7.4:
 
 --abortable_part ::= sequence_of_statements
    function Abortable_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Abortable_Part");
    return Sequence_Of_Statements;
    end Abortable_Part;
 --|
 --|              ||
 --|              | Abort_Statement        |
 --|              |________________________|
 --|
 
 --9.8:
 --abort_statement ::= abort task_name { , task_name }
 
    function Abort_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Abort_Statement");
    if Rt.Current(Current_Code_State).all = "abort"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when Rt.Current(Current_Code_State).all /= ",";
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    return True;
    end Abort_Statement;
 --|
 --|              ||
 --|              ||
 --|              |  Compilation           |
 --|              |________________________|
 --|              |________________________|
 --|
 
 --10.1.1:
 --compilation ::= { compilation_unit }
 
    function Compilation return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Compilation");
    Dummy := Compilation_Unit;
    loop
       exit when Rt.Current(Current_Code_State).all = ""
       or else not Compilation_Unit;
    end loop;
    return True;
    end Compilation;
 
 --|
 --|              ||
 --|              |  Compilation_Unit      |
 --|              |________________________|
 --|
 
 --10.1.1:
 --compilation_unit ::=
 --context_clause library_item
 --|context_clause subunit
 
    function Compilation_Unit return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Compilation_Unit");
    if not Context_Clause
       then
       Set_Error_Message(To => " context clause error");
       Rt.Trace(" context clause error");
       return False;
    end if;
    if Library_Item
       then
       return True;
       elsif Subunit
       then
       return True;
       else
       Set_Error_Message(To => " Subunit error");
       Rt.Trace(" Subunit error");
       return False;
    end if;
    end Compilation_Unit;
 --|
 --|              ||
 --|              |  Library_Item          |
 --|              |________________________|
 --|
 --10.1.1:
 --library_item ::= [private] library_unit_declaration
 --|library_unit_body
 --| [private] library_unit_renaming_declaration
 
    function Library_Item
    return Boolean
    is
    Result             : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Library_Item");
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       if not Library_Unit_Declaration or else Library_Unit_Renaming_Declaration
          then
          Rt.Trace("Library_Item returns A ");
          return True;
          else
          Set_Error_Message(To => "Library_Item Declaration");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Result := Library_Unit_Declaration or else Library_Unit_Body or else Library_Unit_Renaming_Declaration;
    Rt.Trace("Library_Item returns B " & Boolean'Image(Result));
    if not Result
       then
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Library_Item Body");
       return False;
    end if;
    return True;
    end Library_Item;
 --|
 --|              ||
 --|              | library_unit_declaration                       |
 --|              |________________________________________________|
 --|
 --10.1.1:
 --library_unit_declaration ::=
 --subprogram_declaration|package_declaration
 --|generic_declaration|generic_instantiation
 
    function Library_Unit_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("Library_Unit_Declaration");
    Result := Subprogram_Declaration
    or else Package_Declaration
    or else Generic_Declaration
    or else Generic_Instantiation;
    Rt.Trace("Library_Unit_Declaration return " & Boolean'Image(Result));
    return Result;
    end Library_Unit_Declaration;
 --|
 --|
 --|              ||
 --|              | library_unit_renaming_declaration              |
 --|              |________________________________________________|
 --|
 --10.1.1:
 --library_unit_renaming_declaration ::=
 --package_renaming_declaration
 --|generic_renaming_declaration
 --|subprogram_renaming_declaration
 
    function Library_Unit_Renaming_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("Library_Unit_Renaming_Declaration");
    Result := Package_Renaming_Declaration
    or else Generic_Renaming_Declaration
    or else Subprogram_Renaming_Declaration;
    Rt.Trace("Library_Unit_Renaming_Declaration return " & Boolean'Image(Result));
    return Result;
    end Library_Unit_Renaming_Declaration;
 --|
 --|              ||
 --|              | library_unit_body                              |
 --|              |________________________________________________|
 --|
 --10.1.1:
 --library_unit_body ::= subprogram_body | package_body
 
    function Library_Unit_Body
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Result             : Boolean;
    begin
    Rt.Trace("library_unit_body");
    Result := Subprogram_Body or else Package_Body;
    Rt.Trace("library_unit_body return " & Boolean'Image(Result));
    return Result;
    end Library_Unit_Body;
 --10.1.1:
 
 --parent_unit_name ::= name
 --|
 --|              ||
 --|              |  Context_Clause        |
 --|              |________________________|
 --|
 
 --10.1.2:
 --context_clause ::= { context_item }
 
    function Context_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Context_Clause");
    loop
       exit when not Context_Item;
    end loop;
    return True;
    end Context_Clause;
 --|
 --|              ||
 --|              | Context_Item           |
 --|              |________________________|
 --|
 
 --10.1.2:
 --context_item ::= with_clause | use_clause
 
    function Context_Item
    return Boolean
    is
    begin
    Rt.Trace("Context_Item");
    return With_Clause or else Use_Clause or else Pragma_X;
    end Context_Item;
 --|
 --|              ||
 --|              | With_Clause            |
 --|              |________________________|
 --|
 
 --10.1.2:
 --with_clause ::= with library_unit_name { , library_unit_name };
 
    function With_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("With_Clause : " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not (Rt.Current(Current_Code_State).all = ",");
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon With_Clause");
       return False;
    end if;
    return True;
    end With_Clause;
 
 --|              ||
 --|              |                Body_Stub                       |
 --|              |________________________________________________|
 --|
 
 --10.1.3:
 
 --body_stub ::= subprogram_body_stub | package_body_stub | task_body_stub | protected_body_stub
    function Body_Stub
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Body_Stub");
    return Subprogram_Body_Stub
    or else Package_Body_Stub
    or else Task_Body_Stub
    or else Protected_Body_Stub;
    end Body_Stub;
 --|
 --|              ||
 --|              |              Subprogram_Body_Stub              |
 --|              |________________________________________________|
 --|
 --10.1.3:
 
 --subprogram_body_stub ::= subprogram_specification is separate;
    function Subprogram_Body_Stub
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Body_Stub");
    if not Subprogram_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "separate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Subprogram_Body_Stub");
       return False;
    end if;
    return True;
    end Subprogram_Body_Stub;
 --|
 --|              ||
 --|              |       Package_Body_Stub                        |
 --|              |________________________________________________|
 --|
 --10.1.3:
 
 --package_body_stub ::= package body defining_identifier is separate;
    function Package_Body_Stub
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Package_Body_Stub");
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "separate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Package_Body_Stub");
       return False;
    end if;
    return True;
    end Package_Body_Stub;
 --|
 --|              ||
 --|              |         Task_Body_Stub                         |
 --|              |________________________________________________|
 --|
 --10.1.3:
 
 --task_body_stub ::= task body defining_identifier is separate;
    function Task_Body_Stub
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Task_Body_Stub");
    if Rt.Current(Current_Code_State).all = "task"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "separate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Task_Body_Stub");
       return False;
    end if;
    return True;
    end Task_Body_Stub;
 --|
 --|              ||
 --|              |          Protected_Body_Stub                   |
 --|              |________________________________________________|
 --|
 --10.1.3:
 
 --protected_body_stub ::= protected body defining_identifier is separate;
    function Protected_Body_Stub
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Protected_Body_Stub");
    if Rt.Current(Current_Code_State).all = "protected"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "body"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "separate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Protected_Body_Stub");
       return False;
    end if;
    return True;
    end Protected_Body_Stub;
 --|
 --|              ||
 --|              |               Subunit                          |
 --|              |________________________________________________|
 --|
 --10.1.3:
 
 --subunit ::= separate (parent_unit_name) proper_body
    function Subunit
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subunit");
    if Rt.Current(Current_Code_State).all = "separate"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Proper_Body
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Subunit;
 --|
 --|              ||
 --|              |            Exception_Declaration               |
 --|              |________________________________________________|
 --|
 --11.1:
 
 --exception_declaration ::= defining_identifier_list : exception;
    function Exception_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Exception_Declaration");
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "exception"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Exception_Declaration");
       return False;
    end if;
    return True;
    end Exception_Declaration;
 --|
 --|              ||
 --|              | Handled_Sequence_Of_Statements            |
 --|              |___________________________________________|
 --|
 
 --11.2:
 --handled_sequence_of_statements ::=
 --sequence_of_statements
 --[exception
 --exception_handler
 --{ exception_handler }]
 
    function Handled_Sequence_Of_Statements
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Handled_Sequence_Of_Statements" & Rt.Current(Current_Code_State).all);
    if not Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "exception"
       then
       Rt.Read(Current_Code_State);
       loop
          exit when not Exception_Handler;
       end loop;
    end if;
    return True;
    end Handled_Sequence_Of_Statements;
 --|
 --|              ||
 --|              | Exception_Handler                         |
 --|              |___________________________________________|
 --|
 
 --11.2:
 --exception_handler ::=
 --when [ choice_parameter_specification:] exception_choice { | exception_choice } =>
 --sequence_of_statements
 
    function Exception_Handler
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    Temp_Code_State    : Rt.Code_State_Type;
    begin
    Rt.Trace("Exception_Handler  when " & Rt.Current(Current_Code_State).all);
    if Rt.Current(Current_Code_State).all = "when"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Temp_Code_State := Current_Code_State;
    if Choice_Parameter_Specification
       then
       if Rt.Current(Current_Code_State).all = ":"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Temp_Code_State;
       end if;
    end if;
    if not Exception_Choice
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not (Rt.Current(Current_Code_State).all = "|");
       Rt.Read(Current_Code_State);
       if not Exception_Choice
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end loop;
    Rt.Trace("Exception_Handler=>" & Rt.Current(Current_Code_State).all);
 
    if Rt.Current(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Sequence_Of_Statements
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Exception_Handler;
 --|
 --|              ||
 --|              |        Choice_Parameter_Specification          |
 --|              |________________________________________________|
 --|
 --11.2:
 
 --choice_parameter_specification ::= defining_identifier
    function Choice_Parameter_Specification
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Choice_Parameter_Specification" & Rt.Current(Current_Code_State).all);
    return A_Name;
    end Choice_Parameter_Specification;
 --|
 --|              ||
 --|              |              Exception_Choice                  |
 --|              |________________________________________________|
 --|
 --11.2:
 
 --exception_choice ::= exception_name | others
    function Exception_Choice
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Exception_Choice" & Rt.Current(Current_Code_State).all);
    if A_Name
       then
       return True;
       elsif Rt.Current(Current_Code_State).all = "others"
       then
       Rt.Read(Current_Code_State);
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    end Exception_Choice;
 --|
 --|              ||
 --|              | Raise_Statement                           |
 --|              |___________________________________________|
 --|
 
 --11.3:
 --raise_statement ::= raise [exception_name];
 
    function Raise_Statement
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Raise_Statement");
    if Rt.Current(Current_Code_State).all = "raise"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := A_Name;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Raise_Statement");
       return False;
    end if;
    end Raise_Statement;
 --|
 --|              ||
 --|              |           Generic_Declaration                  |
 --|              |________________________________________________|
 --|
 --12.1:
 
 --generic_declaration ::= generic_subprogram_declaration | generic_package_declaration
    function Generic_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Declaration");
    return Generic_Subprogram_Declaration or else Generic_Package_Declaration;
    end Generic_Declaration;
 --|
 --|              ||
 --|              |            Generic_Subprogram_Declaration      |
 --|              |________________________________________________|
 --|
 --12.1:
 
 --generic_subprogram_declaration ::=
 --generic_formal_part  subprogram_specification;
    function Generic_Subprogram_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Subprogram_Declaration");
    if not Generic_Formal_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Subprogram_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Generic_Subprogram_Declaration");
       return False;
    end if;
    return True;
    end Generic_Subprogram_Declaration;
 --|
 --|              ||
 --|              |          Generic_Package_Declaration           |
 --|              |________________________________________________|
 --|
 --12.1:
 
 --generic_package_declaration ::=
 --generic_formal_part  package_specification;
    function Generic_Package_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Package_Declaration");
    if not Generic_Formal_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Package_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Generic_Package_Declaration");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Generic_Package_Declaration;
 --|
 --|              ||
 --|              |          Generic_Formal_Part                   |
 --|              |________________________________________________|
 --|
 
 --12.1:
 --generic_formal_part ::= generic { generic_formal_parameter_declaration | use_clause }
 
    function Generic_Formal_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Formal_Part");
    if Rt.Current(Current_Code_State).all = "generic"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    loop
       exit when not (Generic_Formal_Parameter_Declaration or else Use_Clause);
    end loop;
    return True;
    end Generic_Formal_Part;
 --|
 --|              ||
 --|              |    Generic_Formal_Parameter_Declaration        |
 --|              |________________________________________________|
 --|
 --12.1:
 
 --generic_formal_parameter_declaration ::=
 --formal_object_declaration
 --|formal_type_declaration
 --|formal_subprogram_declaration
 --|formal_package_declaration
    function Generic_Formal_Parameter_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Formal_Parameter_Declaration");
    return Formal_Object_Declaration
    or else Formal_Type_Declaration
    or else Formal_Subprogram_Declaration
    or else Formal_Package_Declaration;
    end Generic_Formal_Parameter_Declaration;
 --|
 --|              ||
 --|              |       Generic_Instantiation                    |
 --|              |________________________________________________|
 --|
 --12.3:
 
 --generic_instantiation ::=
 --package defining_program_unit_name is
 --new generic_package_name [generic_actual_part];
 --|procedure defining_program_unit_name is
 --new generic_procedure_name [generic_actual_part];
 --|function defining_designator is
 --new generic_function_name [generic_actual_part];
    function Generic_Instantiation
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Instantiation");
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       if not Defining_Program_Unit_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "is"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "new"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Dummy := Generic_Actual_Part;
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          Set_Error_Message(To => "Missing Semicolon Generic_Instantiation");
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       return True;
       elsif Rt.Current(Current_Code_State).all = "procedure"
       then
       Rt.Read(Current_Code_State);
       if not Defining_Program_Unit_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "is"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "new"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Dummy := Generic_Actual_Part;
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Set_Error_Message(To => "Missing Semicolon Generic_Instantiation");
          return False;
       end if;
       return True;
       elsif Rt.Current(Current_Code_State).all = "function"
       then
       Rt.Read(Current_Code_State);
       if not Defining_Designator
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "is"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = "new"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       Dummy := Generic_Actual_Part;
       if Rt.Current(Current_Code_State).all = ";"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          Set_Error_Message(To => "Missing Semicolon Generic_Instantiation");
          return False;
       end if;
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    end Generic_Instantiation;
 --|
 --|              ||
 --|              |               Generic_Actual_Part              |
 --|              |________________________________________________|
 --|
 --12.3:
 
 --generic_actual_part ::=
 --(generic_association { , generic_association })
    function Generic_Actual_Part
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Actual_Part");
    if not Expression_A --Generic_Association
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Generic_Actual_Part;
 --|
 --|              ||
 --|              |              Generic_Association               |
 --|              |________________________________________________|
 --|
 --12.3:
 
 --generic_association ::=
 --[generic_formal_parameter_selector_name =>] explicit_generic_actual_parameter
    function Generic_Association
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Generic_Association");
    if Selector_Name
       then
       if Rt.Current(Current_Code_State).all = "=>"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if not Explicit_Generic_Actual_Parameter
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Generic_Association;
 --|
 --|              ||
 --|              |      Explicit_Generic_Actual_Parameter         |
 --|              |________________________________________________|
 --|
 --12.3:
 
 --explicit_generic_actual_parameter ::= expression | variable_name
 --|subprogram_name | entry_name | subtype_mark
 --|package_instance_name
    function Explicit_Generic_Actual_Parameter
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Explicit_Generic_Actual_Parameter");
    return Expression or else Expression_A;
    end Explicit_Generic_Actual_Parameter;
 --|
 --|              ||
 --|              |           Formal_Object_Declaration            |
 --|              |________________________________________________|
 --|
 --12.4:
 
 --formal_object_declaration ::=
 --defining_identifier_list : mode subtype_mark [:= default_expression];
    function Formal_Object_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Object_Declaration");
    if not Defining_Identifier_List
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Mode_X
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A --220502
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ":="
       then
       Rt.Read(Current_Code_State);
       if not Expression_A
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Formal_Object_Declaration");
       return False;
    end if;
    return True;
    end Formal_Object_Declaration;
 --|
 --|              ||
 --|              |            Formal_Type_Declaration             |
 --|              |________________________________________________|
 --|
 --12.5:
 
 --formal_type_declaration ::=
 --type defining_identifier[discriminant_part] is formal_type_definition;
    function Formal_Type_Declaration
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Type_Declaration");
    if Rt.Current(Current_Code_State).all = "type"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Discriminant_Part;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Formal_Type_Definition
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Formal_Type_Declaration");
       return False;
    end if;
    return True;
    end Formal_Type_Declaration;
 --|
 --|              ||
 --|              |            formal_type_definition              |
 --|              |________________________________________________|
 --|
 --12.5:
 
 --formal_type_definition ::=
 --formal_private_type_definition
 --|formal_derived_type_definition
 --|formal_discrete_type_definition
 --|formal_signed_integer_type_definition
 --|formal_modular_type_definition
 --|formal_floating_point_definition
 --|formal_ordinary_fixed_point_definition
 --|formal_decimal_fixed_point_definition
 --|formal_array_type_definition
 --|formal_access_type_definition
    function Formal_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Type_Definition");
    return Formal_Private_Type_Definition
    or else Formal_Derived_Type_Definition
    or else Formal_Discrete_Type_Definition
    or else Formal_Signed_Integer_Type_Definition
    or else Formal_Modular_Type_Definition
    or else Formal_Floating_Point_Definition
    or else Formal_Ordinary_Fixed_Point_Definition
    or else Formal_Decimal_Fixed_Point_Definition
    or else Formal_Array_Type_Definition
    or else Formal_Access_Type_Definition;
    end Formal_Type_Definition;
 --|
 --|              ||
 --|              |        Formal_Private_Type_Definition          |
 --|              |________________________________________________|
 --|
 --12.5.1:
 
 --formal_private_type_definition ::= [[abstract] tagged] [limited] private
    function Formal_Private_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Private_Type_Definition");
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "tagged"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "limited"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "private"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Private_Type_Definition;
 --|
 --|              ||
 --|              |           Formal_Derived_Type_Definition       |
 --|              |________________________________________________|
 --|
 --12.5.1:
 
 --formal_derived_type_definition ::= [abstract] new subtype_mark [with private]
    function Formal_Derived_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Derived_Type_Definition");
    if Rt.Current(Current_Code_State).all = "abstract"
       then
       Rt.Read(Current_Code_State);
    end if;
    if Rt.Current(Current_Code_State).all = "new"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = "private"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Formal_Derived_Type_Definition;
 --|
 --|              ||
 --|              |           Formal_Discrete_Type_Definition      |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_discrete_type_definition ::= (<>)
    function Formal_Discrete_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Discrete_Type_Definition");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ")"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Discrete_Type_Definition;
 --|
 --|              ||
 --|              |       Formal_Signed_Integer_Type_Definition    |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_signed_integer_type_definition ::= range <>
    function Formal_Signed_Integer_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Signed_Integer_Type_Definition");
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Signed_Integer_Type_Definition;
 --|
 --|              ||
 --|              |         Formal_Modular_Type_Definition         |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_modular_type_definition ::= mod <>
    function Formal_Modular_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Modular_Type_Definition");
    if Rt.Current(Current_Code_State).all = "mod"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Modular_Type_Definition;
 --|
 --|              ||
 --|              |         Formal_Floating_Point_Definition       |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_floating_point_definition ::= digits <>
    function Formal_Floating_Point_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Floating_Point_Definition");
    if Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Floating_Point_Definition;
 --|
 --|              ||
 --|              |       Formal_Ordinary_Fixed_Point_Definition   |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_ordinary_fixed_point_definition ::= delta <>
    function Formal_Ordinary_Fixed_Point_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Ordinary_Fixed_Point_Definition");
    if Rt.Current(Current_Code_State).all = "delta"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Ordinary_Fixed_Point_Definition;
 --|
 --|              ||
 --|              |         Formal_Decimal_Fixed_Point_Definition  |
 --|              |________________________________________________|
 --|
 --12.5.2:
 
 --formal_decimal_fixed_point_definition ::= delta <> digits <>
    function Formal_Decimal_Fixed_Point_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Decimal_Fixed_Point_Definition");
    if Rt.Current(Current_Code_State).all = "delta"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "digits"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Formal_Decimal_Fixed_Point_Definition;
 --|
 --|              ||
 --|              |          Formal_Array_Type_Definition          |
 --|              |________________________________________________|
 --|
 --12.5.3:
 
 --formal_array_type_definition ::= array_type_definition
    function Formal_Array_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Array_Type_Definition");
    return Array_Type_Definition;
    end Formal_Array_Type_Definition;
 --|
 --|              ||
 --|              |         Formal_Access_Type_Definition          |
 --|              |________________________________________________|
 --|
 --12.5.4:
 
 --formal_access_type_definition ::= access_type_definition
    function Formal_Access_Type_Definition
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Access_Type_Definition");
    return Access_Type_Definition;
    end Formal_Access_Type_Definition;
 --|
 --|              ||
 --|              |        Formal_Subprogram_Declaration           |
 --|              |________________________________________________|
 --|
 --12.6:
 --formal_subprogram_declaration ::= with subprogram_specification [is subprogram_default];
    function Formal_Subprogram_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Subprogram_Declaration");
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Subprogram_Specification
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       if not Subprogram_Default
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Formal_Subprogram_Declaration");
       return False;
    end if;
    return True;
    end Formal_Subprogram_Declaration;
 --|
 --|              ||
 --|              |           Subprogram_Default                   |
 --|              |________________________________________________|
 --|
 --12.6:
 
 --subprogram_default ::= default_name | <>
    function Subprogram_Default
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Subprogram_Default");
    if Rt.Current(Current_Code_State).all = "<>"
       then
       Rt.Read(Current_Code_State);
       return True;
       elsif A_Name
       then
       return True;
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    end Subprogram_Default;
 --|
 --|              ||
 --|              |             Default_Name                       |
 --|              |________________________________________________|
 --|
 --12.6:
 
 --default_name ::= name
    function Default_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Default_Name");
    return A_Name;
    end Default_Name;
 --|
 --|              ||
 --|              |      Formal_Package_Declaration                |
 --|              |________________________________________________|
 --|
 --12.7:
 
 --formal_package_declaration ::=
 --with package defining_identifier is new generic_package_name  formal_package_actual_part;
    function Formal_Package_Declaration
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Package_Declaration");
    if Rt.Current(Current_Code_State).all = "with"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "package"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;	
    if Rt.Current(Current_Code_State).all = "is"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "new"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Formal_Package_Actual_Part
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Formal_Package_Declaration");
       return False;
    end if;
    return True;
    end Formal_Package_Declaration;
 --|
 --|              ||
 --|              |       Formal_Package_Actual_Part               |
 --|              |________________________________________________|
 --|
 --12.7:
 
 --formal_package_actual_part ::=
 --(<>) | [generic_actual_part]
    function Formal_Package_Actual_Part
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Formal_Package_Actual_Part");
    if Rt.Current(Current_Code_State).all = "("
       then
       Rt.Read(Current_Code_State);
       if Rt.Current(Current_Code_State).all = "<>"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
       if Rt.Current(Current_Code_State).all = ")"
          then
          Rt.Read(Current_Code_State);
          else
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    Dummy := Generic_Actual_Part;
    return True;
    end Formal_Package_Actual_Part;
 --|
 --|              ||
 --|              |           Representation_Clause                |
 --|              |________________________________________________|
 --|
 --13.1:
 
 --representation_clause ::= attribute_definition_clause
 --|enumeration_representation_clause
 --|record_representation_clause
 --|at_clause
    function Representation_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Representation_Clause");
    return Attribute_Definition_Clause
    or else Enumeration_Representation_Clause
    or else Record_Representation_Clause
    or else At_Clause;
    end Representation_Clause;
 --|
 --|              ||
 --|              |           Local_Name                           |
 --|              |________________________________________________|
 --|
 --13.1:
 
 --local_name ::= direct_name
 --|direct_name'attribute_designator
 --|library_unit_name
    function Local_Name
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Local_Name");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "'"
       then
       Rt.Read(Current_Code_State);
       if not A_Name
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Local_Name;
 --|
 --|              ||
 --|              |        Attribute_Definition_Clause             |
 --|              |________________________________________________|
 --|
 --13.3:
 
 --attribute_definition_clause ::=
 --for local_name'attribute_designator use expression;
 --|for local_name'attribute_designator use name;
    function Attribute_Definition_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Attribute_Definition_Clause");
    if Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not (Expression_A or else A_Name)
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Attribute_Definition_Clause");
       return False;
    end if;
    return True;
    end Attribute_Definition_Clause;
 --|
 --|              ||
 --|              |     Enumeration_Representation_Clause          |
 --|              |________________________________________________|
 --|
 --13.4:
 
 --enumeration_representation_clause ::=
 --for first_subtype_local_name use enumeration_aggregate;
    function Enumeration_Representation_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Enumeration_Representation_Clause");
    if Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Enumeration_Aggregate
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Enumeration_Representation_Clause");
       return False;
    end if;
    return True;
    end Enumeration_Representation_Clause;
 --|
 --|              ||
 --|              |         Enumeration_Aggregate                  |
 --|              |________________________________________________|
 --|
 --13.4:
 
 --enumeration_aggregate ::= array_aggregate
    function Enumeration_Aggregate
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Enumeration_Aggregate");
    return Array_Aggregate;
    end Enumeration_Aggregate;
 --|
 --|              ||
 --|              |       Record_Representation_Clause             |
 --|              |________________________________________________|
 --|
 --13.5.1:
 
 --record_representation_clause ::=
 --for first_subtype_local_name use
 --record [mod_clause]
 --{ component_clause }
 --end record;
    function Record_Representation_Clause
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Record_Representation_Clause");
    if Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Mod_Clause;
    loop
       exit when not Component_Clause;
    end loop;
    if Rt.Current(Current_Code_State).all = "end"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "record"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Record_Representation_Clause");
       return False;
    end if;
    return True;
    end Record_Representation_Clause;
 --|
 --|              ||
 --|              |        Component_Clause                        |
 --|              |________________________________________________|
 --|
 --13.5.1:
 
 --component_clause ::=
 --component_local_name at position range first_bit .. last_bit;
    function Component_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Component_Clause");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "at"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Position
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "range"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression_A
       then
       Current_Code_State := Code_State_In_Test;--
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Component_Clause");
       return False;
    end if;
    return True;
    end Component_Clause;
 --|
 --|              ||
 --|              |              Position                          |
 --|              |________________________________________________|
 --|
 --13.5.1:
 
 --position ::= static_expression
    function Position
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Position");
    return Expression;
    end Position;
 --|
 --|              ||
 --|              |              First_Bit                         |
 --|              |________________________________________________|
 --|
 --13.5.1:
 
 --first_bit ::= static_simple_expression
    function First_Bit
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("First_Bit");
    return Expression;
    end First_Bit;
 --|
 --|              ||
 --|              |               Last_Bit                         |
 --|              |________________________________________________|
 --|
 --13.5.1:
 
 --last_bit ::= static_simple_expression
    function Last_Bit
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Last_Bit");
    return Expression;
    end Last_Bit;
 --|
 --|              ||
 --|              |              Code_Statement                    |
 --|              |________________________________________________|
 --|
 --13.8:
 
 --code_statement ::= qualified_expression;
    function Code_Statement
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Code_Statement");
    if not Qualified_Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Set_Error_Message(To => "Missing Semicolon Code_Statement");
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    return True;
    end Code_Statement;
 --|
 --|              ||
 --|              |              Restriction                       |
 --|              |________________________________________________|
 --|
 --13.12:
 
 --restriction ::= restriction_identifier
 --|restriction_parameter_identifier => expression
    function Restriction
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Restriction");
    if not A_Name
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "=>"
       then
       Rt.Read(Current_Code_State);
       if not Expression
          then
          Current_Code_State := Code_State_In_Test;
          return False;
       end if;
    end if;
    return True;
    end Restriction;
 --|
 --|              ||
 --|              |          Delta_Constraint                      |
 --|              |________________________________________________|
 --|
 --J.3:
 
 --delta_constraint ::= delta static_expression [range_constraint]
    function Delta_Constraint
    return Boolean
    is
    Dummy              : Boolean;
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Delta_Constraint");
    if Rt.Current(Current_Code_State).all = "delta"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    Dummy := Range_Constraint;
    return True;
    end Delta_Constraint;
 --|
 --|              ||
 --|              |             At_Clause                          |
 --|              |________________________________________________|
 --|
 --J.7:
 --at_clause ::= for direct_name use at expression;
    function At_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("At_Clause");
    if Rt.Current(Current_Code_State).all = "for"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = Rt.Identifier
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "use"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "at"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon At_Clause");
       return False;
    end if;
    return True;
    end At_Clause;
 --|
 --|              ||
 --|              |                                                |
 --|              |________________________________________________|
 --|
 
 
 --J.8:
 
 --mod_clause ::= at mod static_expression;
    function Mod_Clause
    return Boolean
    is
    Code_State_In_Test : Rt.Code_State_Type := Current_Code_State;
    begin
    Rt.Trace("Mod_Clause");
    if Rt.Current(Current_Code_State).all = "at"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = "mod"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if not Expression
       then
       Current_Code_State := Code_State_In_Test;
       return False;
    end if;
    if Rt.Current(Current_Code_State).all = ";"
       then
       Rt.Read(Current_Code_State);
       else
       Current_Code_State := Code_State_In_Test;
       Set_Error_Message(To => "Missing Semicolon Mod_Clause");
       return False;
    end if;
    return True;
    end Mod_Clause;
 --|
 --|              ||
 --|              | Do_It |
 --|              |_______|
 --|
    function Do_It return Boolean
    is
    Result : Boolean;
    begin
    --|
    --| parse
    --|
    Error_Message.Error_Found := False;
 
    Check :
       begin
 
       Result := Compilation;
 
       exception
       when others => Result := False;
       end Check;
 
    if Error_Message.Error_Found
       --|
       --| parse error ?
       --|
       then
       Rt.Trace("Error Message " & Error_Message.Error_Message_Access.all);
       Rt.Trace("Line Number where parser stopped " & Long_Integer'Image(Error_Message.Line_Number));
       Rt.Trace("Token Position where parser stopped " & Long_Integer'Image(Error_Message.Character_Position));
 
       Ada.Text_Io.Put_Line(File => Ada.Text_Io.Standard_Output,
                            Item => "Error Message "
                            & Error_Message.Error_Message_Access.all);
       Ada.Text_Io.Put_Line(File => Ada.Text_Io.Standard_Output,
                            Item => "Line Number where parser stopped "
                            & Long_Integer'Image(Error_Message.Line_Number));
       Ada.Text_Io.Put_Line(File => Ada.Text_Io.Standard_Output,
                            Item => "Token Position where parser stopped"
                            & Long_Integer'Image(Error_Message.Character_Position));
 
    end if;
    return not Error_Message.Error_Found;
    end Do_It;
 end Gram;
 
 
